//  - ,    t_Render


// ---
//     (-)

void an1_dr_r(float x, float y, float w, float h, DWORD clr)
{
	glSetARGB( clr);

	NomBlend(0);  pix1.off();
	DrawQuad2D_( x, y,  w, h, 0);
//	hge->Gfx_RenderLine( x, y, x+w, y, clr); //argb
//	hge->Gfx_RenderLine( x+w, y, x+w, y+h, clr);
//	hge->Gfx_RenderLine( x+w, y+h, x, y+h, clr);
//	hge->Gfx_RenderLine( x, y+h, x, y, clr);
}

void an1_dr_r2(float x, float y, float x2, float y2, DWORD clr)
{
	glSetARGB( clr);

	NomBlend(0);  pix1.off();
	DrawQuad2D_2( x, y,  x2, y2, 0);

//	hge->Gfx_RenderLine( x, y, x2, y, clr);
//	hge->Gfx_RenderLine( x2, y, x2, y2, clr);
//	hge->Gfx_RenderLine( x2, y2, x, y2, clr);
//	hge->Gfx_RenderLine( x, y2, x, y, clr);
}








	//      //    
void Crt_CircleGoriz( vec2* mOkr, int Doli, float radius, int CCW= 1 )
{
	if( ! mOkr) return;  if(Doli < 3) return;
	float ug =0; //   
	if(CCW != 1) CCW = -1; //   //CCW // 
	float ugD = 360.f / float(Doli) * float(CCW);

	for(int i =0; i < Doli; i++)
	{
		ug = zn::Ring1f( ug, 360);//    0,,360
		mOkr[ i] = vec2( sin(UgDTR(ug)) * radius, cos(UgDTR(ug)) * radius);
		ug += ugD;
	}
}





// ---    
const int an1_Ring64Last = 64;
vec2 an1_Ring064[ an1_Ring64Last +1];

const int an1_Ring32Last = 32;
vec2 an1_Ring032[ an1_Ring32Last +1];

void an1_Rings_init()
{
	//  "  " // 
	Crt_CircleGoriz( an1_Ring064, an1_Ring64Last, 1.f, 0 );
	an1_Ring064[ an1_Ring64Last] = an1_Ring064[ 0];

	Crt_CircleGoriz( an1_Ring032, an1_Ring32Last, 1.f, 0 );
	an1_Ring032[ an1_Ring32Last] = an1_Ring032[ 0];
}



//    
void an1_dr_ring( float x, float y, float x2, float y2, DWORD clr, int just32 =1)
{//     
	vec2 cp, p, n;
	float radiX = (x2 - x) / 2.f; //-
	float radiZ = (y2 - y) / 2.f; //  

	cp.x = x + radiX;
	cp.y = y + radiZ;

	vec2* a;  int anL;
	if(just32){a = &an1_Ring032[0];  anL = an1_Ring32Last;}
	else	{a = &an1_Ring064[0];  anL = an1_Ring64Last;}

	p.x = cp.x + a[0].x * radiX;//
	p.y = cp.y + a[0].y * radiZ;

	glSetARGB( clr);
	NomBlend(0);  pix1.off();
	glBegin(GL_LINES);
	for( int i =1; i <= anL; i++)
	{
		n.x = cp.x + a[i].x * radiX;//-
		n.y = cp.y + a[i].y * radiZ;

		//hge->Gfx_RenderLine( p.x, p.y,  n.x, n.y,  clr);
		glVertex2f( p.x, p.y);  glVertex2f( n.x, n.y);

		p = n; //-  .
	}
	glEnd();

}





// ---------

//   -,   - ..

int GameRectReal_Fru( float RealX, float RealZ, float tW, float tH);


//   ()  -   ..

void GameRectR_ProjToScreen( float RealX, float RealZ,
	float& scrX, float& scrY);


//        - ..

void GameRect_ProjToReal( float scrX, float scrY,
	float& realX, float& realZ);

void ScreenRectToReal( float eX, float eY, float eW, float eH,
	float& rrX, float& rrZ, float& rrW, float& rrH);



void MMapR_ProjToScreen( float RealX, float RealZ, float& scrX, float& scrY);

void MMap_ProjToReal( float scrX, float scrY, float& realX, float& realZ);


void DrawMMap_dot( Fgr* pF, DWORD clr);





/*
   ..

          
   .        ,
   "  -   ".
   0.5       0.2,   
  ,     0.1,  .

,   32*32   64*64   tex_repeat.
4    - -    ,
     .

      ..
LayerLow -      ,  
  sprLow->RenderStretch(ex,ey,  ex2,ey2);
      .

 LayerUnit    (Fgr*)   OnRender.
       .
-     -  .
   .
   sprLaser->Render4V(); //    .
      -       .
// -    .
//       LayerHi   "".

LayerHi -   Low    Stretch.
   -   -.
     ,    
    - ,  ,   ...

           .

*/








// ----------

const int tex0_Rama = 1; //  HTEXTURE  //HTEXTURE    
const int tex0_Ring = 2; //  HTEXTURE    




int  texCur = 3; // 
int  texKru = 9; // -

//const int texFlagLast = 5;
int  texFlag0 = 21;//[texFlagLast+1]; //,     

//const int texArmorLast = 9;
int  texArmor0 = 11;//[texArmorLast+1];//  

int  texKosBunk1 = 35; //- //-
int  texKosKaz1 = 39;  //-
int  texKosEner1 = 37; //-
int  texKosTurBash1 = 57; //-
int  texKosU_Stro = 33; //-
int  texKosU_Raz = 53;  //
int  texKosU_Kom1 = 40; //
int  texKosU_Norm = 49; //
int  texKosU_Jump = 56; // //

int  texNekBunk = 35;
int  texNekArhiv = 32; // 
int  texNekEner = 37;
int  texNekTur = 57;
int  texNekU_Scar = 34; //-
int  texNekU_Krws = 42; // //
int  texNekU_Lord = 41; // 
int  texNekU_Lom = 43;  // //
int  texNekU_Rezak = 58;//

int  texKosLaser = 29; // 
int  texNekLaser = 28; // 






// ---
//          .

class t_QuadZkz
{
public:
DWORD Tex;
DWORD Clr;
float x1, z1, x2, z2; // 
int scrCrd; // 0  1 //-   .
};


class t_pFgrZkz
{
public:
Fgr* pf;
	t_pFgrZkz(){pf=0;}
};




//    ,  "" -..
const int RLowZkzKlv = 75000; //  -  
const int RUnitZkzKlv = 75000;
const int RHiZkzKlv = 75000; //    t_QuadZkz



class t_Render
{
private:

t_QuadZkz  low[ RLowZkzKlv];
t_pFgrZkz  unit[ RUnitZkzKlv];
t_QuadZkz  hi[  RHiZkzKlv];

int lowNow; //      
int unitNow;
int hiNow;


public:
	t_Render(){}


	void Run();


	void OnStartLap()
	{
		lowNow = 0; unitNow = 0; hiNow = 0;
	}


// tex     // tex0_Rama // tex0_Ring
// screenCoord ( -  ).
// O     (GameRectW H)
void Add1( DWORD tex, DWORD clr,
	float realX1, float realZ1, float realX2, float realZ2, int screenCoord =0)
{
	if(lowNow >= RLowZkzKlv) return;

	low[lowNow].Tex = tex; low[lowNow].Clr = clr;
	low[lowNow].x1 = realX1;  low[lowNow].z1 = realZ1;
	low[lowNow].x2 = realX2;  low[lowNow].z2 = realZ2;
	low[lowNow].scrCrd = screenCoord;

	lowNow += 1;
}

void Add1w( DWORD tex, DWORD clr,
	float X, float Z, float W, float H, int screenCoord =0)
{
	Add1( tex, clr, X, Z, X + W, Z + H, screenCoord);
}

void Add1ring( DWORD tex, DWORD clr, vec2 cPos, float radi, int screenCoord =0)
{
	Add1( tex, clr,
	cPos.x - radi, cPos.y - radi, cPos.x + radi, cPos.y + radi, screenCoord);
}


// O     (GameRectW H)
void Add2( Fgr* pFgr)
{
	if(!pFgr) return;
	if(unitNow >= RUnitZkzKlv) return;
	unit[unitNow].pf = pFgr;  unitNow += 1;
}


// O     (GameRectW H)
void Add3( DWORD tex, DWORD clr,
	float realX1, float realZ1, float realX2, float realZ2, int screenCoord =0)
{
	if(hiNow >= RHiZkzKlv) return;

	hi[hiNow].Tex = tex; hi[hiNow].Clr = clr;
	hi[hiNow].x1 = realX1;  hi[hiNow].z1 = realZ1;
	hi[hiNow].x2 = realX2;  hi[hiNow].z2 = realZ2;
	hi[hiNow].scrCrd = screenCoord;

	hiNow += 1;
}

void Add3w( DWORD tex, DWORD clr,
	float X, float Z, float W, float H, int screenCoord =0)
{
	Add3( tex, clr, X, Z, X + W, Z + H, screenCoord);
}

void Add3ring( DWORD tex, DWORD clr, vec2 cPos, float radi, int screenCoord =0)
{
	Add3( tex, clr,
	cPos.x - radi, cPos.y - radi, cPos.x + radi, cPos.y + radi, screenCoord);
}


};

t_Render  Render;


