//      





void t_WarSides::DrawMMap( int allVisible)
{
	int i, t, j;


	glScissor( MMapX, MMapY, MMapW, MMapH);
	glEnable( GL_SCISSOR_TEST);


	//  -    "  ".
	NomBlend(0);  ColorMatF();
		pix1.use(texMMap);
		DrawQuad2D_( MMapX, MMapY, MMapW, MMapH);


	NomBlend(38);  ColorMatF();
		masKle.mapDarkTexBind();
		DrawQuad2D_( MMapX, MMapY, MMapW, MMapH, 1,  1.f, 0.f);




	//  " "  -
	float ex, ey, ex2, ey2;
MMapR_ProjToScreen( GameRectRX, GameRectRZ, ex, ey);
MMapR_ProjToScreen( GameRectRX + GameRectRW, GameRectRZ + GameRectRH, ex2, ey2);

	an1_dr_r2( ex, ey, ex2, ey2, 0xFFFFFFFF);



	DWORD cUnion = 0xFF11AA88;
	DWORD cEnemy = 0xFFFF2255;

	DWORD Clrx[5] = {0xFF888888, 0xFFFF1122, 0xFFFFFF55, 0xFF44FF22, 0xFF2288FF};

	if( allVisible ) //  
	{
		for( j =0; j < 5; j++)
		{
			t = sides[j].ourNow +1;
			for( i =1; i < t; i++)
			{
				//   ,      .
				if(sides[j].banerID == PlayerBanerID)
					DrawMMap_dot( sides[j].our[i], 0xFFFFFFFF);
				else
					DrawMMap_dot( sides[j].our[i], Clrx[j]);
			}
		}

	}
	else if( PlayerBanerOK() )
	{
		j = PlayerBanerID - 1;

		t = sides[j].ourNow +1;
		for( i =1; i < t; i++)  DrawMMap_dot( sides[j].our[i], cUnion);

		t = sides[j].enmNow +1;
		for( i =1; i < t; i++)  DrawMMap_dot( sides[j].enm[i], cEnemy);

	}




	//hge->Gfx_SetClipping();
	glDisable( GL_SCISSOR_TEST);

}





















const int FgrsKlv = 5001;




class t_Fgrs
{
public:

int crtFgrBreak;
int nextFree; //   

Fgr m[FgrsKlv];

t_Fgrs(){ nextFree =1; crtFgrBreak =0; }
~t_Fgrs(){}



	void init()
	{
		for(int i =0; i < FgrsKlv; i++) { m[i].nom = i; }
	}

	void clearAll()
	{
		nextFree =1; crtFgrBreak =0;
		for(int i =0; i < FgrsKlv; i++) { m[i].status = 0; }
	}


	int mOut( int ofsFgr)
	{
		if( ofsFgr < 1 || ofsFgr >= FgrsKlv) return 1;
		return 0;
	}




void ExtraFillAStarLayers()
{
	int i;

	for(i =1; i < FgrsKlv; i++)
	{//      

		// -  "-   "
		if(m[i].status < fgrDomKosBunk || m[i].status > fgrDomNekPost)
			continue;

		// ------
		//     -       ..
		//if( m[i].status == fgrDomKosBunk || m[i].status == fgrDomNekBunk)
		//{
		//	int t = masKle.Kle_FromXZ( m[i].ox - 2.f, m[i].oz - 2.f);
		//		//   ,     .
		//		//     4-  -  -.
		//	masKle.AStarLaySet1( t, 0, 1, 1, 1, 1);
		//	masKle.AStarLaySet1( t +1, 0, 1, 1, 1, 1);
		//	masKle.AStarLaySet1( t +KleXKlv, 0, 1, 1, 1, 1);
		//	masKle.AStarLaySet1( t +KleXKlv +1, 0, 1, 1, 1, 1);
		//}else{
					//     ..
			masKle.AStarLaySet1( masKle.Kle_FromXZ( m[i].ox, m[i].oz),
			0, 1, 1, 1, 1);
		//}
	}


	for(i =1; i < FgrsKlv; i++)
	{
		//   ,    "   ".
		m[i].TryFindWay(); //    
	}

}




void XUp_SvetOnMap()
{
	masKle.mapDarkSbros();
	for(int i =1; i < FgrsKlv; i++)
	{
		if( m[i].Active() )
		{
		 	if(m[i].baner == PlayerBanerID && m[i].rObserv > KleW)
				masKle.mapDarkAddSvet( m[i].ox, m[i].oz, m[i].rObserv);
		}
	}
}


void DeleteX()
{
	for(int i =1; i < FgrsKlv; i++)
	{
		m[i].KillDeadLinks();
	}
}








// ---
//       (, , )

int Add( int fgrIndex, float PX =0.f, float PY =0.f, float PZ =0.f, void* Adr =0)
{
	// Adr     -   , 
	//    fgrIndex    IFC_xName ...

	if(crtFgrBreak) return 0; //    .
	if(fgrIndex < 1) return 0; //     .
	if( nextFree >= FgrsKlv) return 0;

	Fgr* pF = &m[nextFree];
	if(pF->status)// ,    -.
	{
		for(int i =0; i < FgrsKlv; i++)//  
		{
			nextFree += 1; if(nextFree+1 > FgrsKlv) nextFree = 1;
			pF = &m[nextFree];  if(!pF->status) break;//for
		}
	}



	// ---        ..

	pF->Sbros();

	int res =0;
	switch( fgrIndex )
	{
	//case fgrTest1: res = IFC_Test1( pF, Adr); break;
	//case fgrTest2: res = IFC_Test2( pF, Adr); break;
	case fgrLaser: res = IFC_Laser( pF); break;
	case fgrTriger: res = IFC_Triger( pF); break;
	case fgrPultFlag: res = IFC_PultFlag( pF); break;

	case fgrDomKosBunk: res = IFC_DomKosBunk( pF); break;
	case fgrDomKosKaz:  res = IFC_DomKosKaz( pF); break;
	case fgrDomKosEner: res = IFC_DomKosEner( pF); break;
	case fgrDomKosTur:  res = IFC_DomKosTur( pF); break;
	case fgrDomKosArs:  res = IFC_DomKosArs( pF); break;
	case fgrDomKosPost: res = IFC_DomKosPost( pF); break;

	case fgrUKosBuilder: res = IFC_UKosBuilder( pF); break;
	case fgrUKosRazved:  res = IFC_UKosRazved( pF); break;
	case fgrUKosKom1:  res = IFC_UKosKom1( pF); break;
	case fgrUKosNorm:  res = IFC_UKosNorm( pF); break;
	case fgrUKosJump:  res = IFC_UKosJump( pF); break;

	case fgrDomNekBunk: res = IFC_DomNekBunk( pF); break;
	case fgrDomNekArhiv: res = IFC_DomNekArhiv( pF); break;
	case fgrDomNekEner: res = IFC_DomNekEner( pF); break;
	case fgrDomNekTur:  res = IFC_DomNekTur( pF); break;
	case fgrDomNekArs:  res = IFC_DomNekArs( pF); break;
	case fgrDomNekPost: res = IFC_DomNekPost( pF); break;

	case fgrUNekBuilder: res = IFC_UNekBuilder( pF); break;
	case fgrUNekKrwser: res = IFC_UNekKrwser( pF); break;
	case fgrUNekLord:  res = IFC_UNekLord( pF); break;
	case fgrUNekLom:   res = IFC_UNekLom( pF); break;
	case fgrUNekRezak: res = IFC_UNekRezak( pF); break;

	//case : res = IFC_( pF); break;
	default: return 0;
	}
	if( ! res) return 0; //-  .



	// --- -  ..
	pF->status = fgrIndex; //-      .
	pF->novorod = 1; //    .


	IFC_General_SetPos( pF,  PX, PY, PZ);

	res = nextFree; //  ,    RES   .
	nextFree +=1;
return res; //nextFree  
}


Fgr* Add_( int fgrIndex, float PX =0.f, float PY =0.f, float PZ =0.f, void* Adr =0)
{
	int i = Add( fgrIndex, PX, PY, PZ, Adr);
	if(mOut(i)) return 0;
	return &m[i];
}





// fgrBaner as Zero //any baner
int FindAnyIn( int fgrIndex, int fgrBaner,
	float rx, float rz, float rw, float rh, int mustActive =1)
{
	for(int i =1; i < FgrsKlv; i++)
	{
		if(mustActive) { if( ! m[i].Active() ) continue; }
		if( m[i].status != fgrIndex ) continue;
		if(fgrBaner) { if( m[i].baner != fgrBaner ) continue; }

		if( inRectf( m[i].ox, m[i].oz,  rx, rz, rw, rh) )
			return 1;
	}
	return 0;
}


void SetBaner( int ofsFgr, int valBaner)
{
	if(mOut(ofsFgr)) return;
	m[ofsFgr].baner = valBaner;
}


void Deactive( int ofsFgr)
{
	if(mOut(ofsFgr)) return;
	m[ofsFgr].active = 0;
	//  -   ,       
}

void Activate( int ofsFgr)
{
	if(mOut(ofsFgr)) return;
	m[ofsFgr].active = 1;
}


void SetTrigerAct( int ofsFgr, int actFgr, int trigWait =5000)
{
	if(mOut(ofsFgr)) return;
	m[ofsFgr].activateFgr = actFgr;
	// actFgr      -   .
	//      " "  pF->activateExt

	//  " " //  -   
	m[ofsFgr].UdarWaitI = trigWait;
	m[ofsFgr].AnyAtakWait = trigWait;
}

void SetTrigerExt( int ofsFgr, int actExt, int trigWait =5000)
{
	if(mOut(ofsFgr)) return;
	m[ofsFgr].activateExt = actExt;

	m[ofsFgr].UdarWaitI = trigWait;
	m[ofsFgr].AnyAtakWait = trigWait;
}




void SetPathPoint( int ofsFgr, float rx, float rz)
{
	if(mOut(ofsFgr)) return;
	m[ofsFgr].TrySetPathKle( rx, rz);
}







void CreateX()
{
	for(int i =1; i < FgrsKlv; i++)
	{
		if( m[i].novorod == 1) //   ,  .
			m[i].novorod = 0;
	}
}


void Upd1()
{
crtFgrBreak = 1; // "  "  Upd1

	for(int i =1; i < FgrsKlv; i++)
	{
		if( m[i].Active() ) m[i].UpdSelf();
	}

crtFgrBreak = 0;
}




void Upd2Norm()
{
	for(int i =1; i < FgrsKlv; i++)
	{
		if( m[i].Active() )  m[i].TryUpd2Norm();
	}
}

void Draw()
{
// ,     -.
	for(int i =1; i < FgrsKlv; i++)
	{
		if( m[i].NeedDraw() )  m[i].TryDraw();
	}
}









int pere( Fgr* pF, float& rX, float& rZ, float& rW, float& rH)
{
	//if(!pF) return 0;
	float g = pF->haf -1.f; // 
	float g2 = g * 2.f;
	return RectPere( pF->ox -g, pF->oz -g, g2, g2,  rX, rZ, rW, rH);
}


Fgr* TrySelectSpec( float eX, float eY, float eW, float eH, int fogEnemy =1)
{
float rX, rZ, rW, rH;  ScreenRectToReal( eX, eY, eW, eH, rX, rZ, rW, rH);

	Fgr* pF = 0;

	for(int i =1; i < FgrsKlv; i++)
	{
		pF = &( m[i] );  if( ! pF->NeedDraw() ) continue;
		if( ! pF->isUnit() ) continue;

		//m[i].DrawForSelect();
		if(pere(pF, rX, rZ, rW, rH))
		{
			if(fogEnemy)
			{
				if(PlayerBanerID == pF->baner) return pF;
				else if( pF->KlientVidit) return pF;

				return 0; //  -   .
			}
			else return pF; //  
		}
	}//for
	return 0;
}


//     .
int TrySelectUnit( float eX, float eY, float eW, float eH, int isOne =0)
{
float rX, rZ, rW, rH;  ScreenRectToReal( eX, eY, eW, eH, rX, rZ, rW, rH);

	if(! isOne) Sel.SelReset();

	Fgr* pF;
	int klv =0;
	for(int i =1; i < FgrsKlv; i++)
	{
		pF = &( m[i] );  if( ! pF->NeedDraw() ) continue;
		if( ! pF->isUnit() ) continue;

		if(pere(pF, rX, rZ, rW, rH))
		{
			if(isOne)
			{	Sel.SelFgr( pF );
				return 1; //  
			}
			if( pF->on_SelMass_FilterUnit( PlayerBanerID) )
			{
				klv +=1;
				Sel.SelAdd( pF );
			}
		}
	}//for
	return klv;
}


int TrySelectFgr( float eX, float eY, float eW, float eH, int isOne =0)
{ //  TrySelectUnit,   isUnit & on_SelMass_FilterUnit

float rX, rZ, rW, rH;  ScreenRectToReal( eX, eY, eW, eH, rX, rZ, rW, rH);

	if(! isOne) Sel.SelReset(); //      

	Fgr* pF;
	int klv =0;
	for(int i =1; i < FgrsKlv; i++)
	{
		pF = &( m[i] );  if( ! pF->NeedDraw() ) continue;

		if(pere(pF, rX, rZ, rW, rH))
		{
			if(isOne)
			{	Sel.SelFgr( pF );
				return 1; //  
			}

			klv +=1;
			Sel.SelAdd( pF );
		}
	}//for
	return klv;
}





}; // class t_Fgrs

t_Fgrs Fgrs;













void Fgrs_Activate( int nom)
{
	Fgrs.Activate( nom);
}





void Fgrs_SetPathPoint( int ofsFgr, int direction)
{
	//direction      //  .
	//     ,   "  ".
	if(Fgrs.mOut(ofsFgr)) return;
	Fgrs.m[ofsFgr].oz += KleW / 2.f;
}







void PultFlag_SetVers( Fgr* pF, int klStroX)
{
	if(!pF) return;

	if(klStroX == klStroCtrl)
	{
		pF->rObserv = 120.f;
		// ...
	}
	else
	{
		pF->rObserv = 60.f;
		// ...
	}
}




void Fgrs_AddPultFlag( int kle, Fgr* pF)
{
	if(!pF) return; //     .

	//if( masKle.KleOut(kle) ) return; //  .
	//  ,   100%     .

	float x, z;  masKle.XZ_FromKle( x,z, kle, 1); //  

	Fgr* nf = Fgrs.Add_( fgrPultFlag, x, 0, z);  if( !nf ) return;

	nf->baner = pF->baner;
	nf->activateFgr = pF->nom;

	PultFlag_SetVers( nf,  masKle.m[kle].stroim);

	masKle.m[kle].fgr = nf; //       .
	//         ,   
	//   .   " "  -.
	//  -    " ".
	//   --       ,
	//        
	//  -,    "  ".

	pF->active = 0; //        
	pF->targPathKle = 0;

}


















void Fgr::UpdSelf()
{
//   status = 0;

	if( isMort )
	{
			if( zn::ToZeroi(isMort) ) status = 0;
		return;
	}
	//  WarSides.AddUnit( this);    -    
	//       ,    
	//       ,    .



	// ...
	//  ,      , 
	//    " ".


	// -----
	//         .
	//          .
	//          
	//    (    ) ...

	WarSides.AddUnit( this);



wasSelfUpd = 1; //  
}





int Fgr::invisNow()
{ //    -      ??
	// ...
	return 0; // 0 or 1
}


float Fgr::detectNow()
{ // 0.f       .
	// ...
	return KleW * 1.5f;
	//    "",      .
}




void Fgr::Draw_SpeOkrugs()
{
	if(  Sel.underCursor == this
		||(Sel.underCursor==0 &&  isSelected > 0 &&  Sel.Selected1()) )
	{
		Render.Add1ring( tex0_Ring, 0xFFFF5500, vec2(ox, oz), rAtak);

			//   -    
		Render.Add1ring( tex0_Ring, 0xAA00DDFF, vec2(ox, oz), rObserv);
	}
}





void Fgr::TrySetFire( Fgr* pF)
{
	if(!pF) return;

	if( baner != pF->baner) // .   , 
	{ //  "pF"     .
		fireTarg = pF;
		autoTarg = 0; //  " " - -   .

		//     " ",    "pF".
	}
//	else //   -      "    "
//	{ ... }

}








void Fgr::onFinishPath()
{
//  ,   ,
//       " "  .

	// ---
	//    "  "..
	int K = masKle.Kle_FromXZ( ox, oz);

	int onK = masKle.isControlMine( K);

	if( onK) //    -,    .
	{
		if( onK == 1 && AbilConrtolUp) //  -   AbilMineUp
		{
			Fgrs_AddPultFlag( K, this);
			//      ...
			//   .
		}
		// else ...

		return; // -       .
	}


	// ----------
	onK = masKle.isControlPoint( K);

	if(AbilConrtolUp) //   "  -"
	{
		if( onK == 1 ) //  .
		{ //    -.
			Fgrs_AddPultFlag( K, this);
		}
	}
/*	if(AbilConrtolDown) //   "   -"
	{
		if( onK == 2 ) //      
		{
			if( baner != masKle.m[K].fgr->baner )
			{
				//        fgrPultFlag
				// ---
				//  ,   masKle.m[K].fgr->status = 0;
				//   masKle.m[K].fgr = 0;
				//       .
			}
		}
	}
*/

}






void Fgr::TrySetPathKle( float forX, float forZ, int RunToEnemy)
{
	targPathKle = masKle.Kle_FromXZ( forX, forZ);
	if(targPathKle < 0) targPathKle = 0;
	if(RunToEnemy) nearToEnemy = 1; else nearToEnemy = 0;
}





void Fgr::TrySetRally( float rX, float rZ)
{
//  this  ,      -  .

	//if(   )
		TrySetPathKle( rX, rZ);

	fireTarg = 0; //    ,   "   "
	autoTarg = 0;
}





void Fgr::TryFindWay()
{
	//    "-  ".

	if( PafLay == PafLay_UnitDontWalk) return; //  -.

	if( ! targPathKle) return;
	//     ,     
	//    ,     -  
	//   "   ".


	if( onPath && masKle.inBelt1( ox, oz, targPathKle, 1) )
	{
		targPathKle = 0; return; // - ,    .
	}



	int bank =0;

	float PathX, PathZ;
	masKle.XZ_FromKle( PathX, PathZ, targPathKle, 1);

	pathStatus[bank] = FindPath( PafLay,   bank,  ox, oz,  PathX, PathZ);

	onPath = pathStatus[bank];
	if( onPath != 1) return; //   "   "


	// ---
	onPathLen = pathLength[bank];
	onPathNext = 0;

	//if(onPathLen < 5) targPathKle = 0;
	//      ... masKle.inBelt1( ox, oz, targPathKle, 1)
	//    ,       "-".


		int t=0;
		for( int i=0; i < onPathLen; i++)
		{ //  ,    ..
				klePath[i][0] = pathBank[bank][t++];
				klePath[i][1] = pathBank[bank][t++];
		}

	WayStart( KleW);
	//      (onPath==1)  WayAdv();

}






void Fgr::WayStart( float kW)
{
	// --   ..

		unitOpora.x = ox;  unitOpora.y = oz;

		vec2 vTmp;
		vTmp.x = klePath[onPathNext][0] * kW + (kW/2.f);
		vTmp.y = klePath[onPathNext][1] * kW + (kW/2.f);

		vTmp = vTmp - unitOpora;
		unitDir = normalize( vTmp);

		LenFull = length(vTmp);
		LenNow =0.f;
}




void Fgr::WayAdv( float kW)
{
	if( onPath != 1) return;

	LenNow += floMilFrm * skoros;

	if(LenNow > LenFull)
	{

		LenNow -= LenFull;

			if( (onPathNext + 1) == onPathLen)
			{ //   , 
				onPath = 0;

				onFinishPath(); //    

				//targPathKle = 0;
				//onPathLen = 0;
			}
			else // 
			{
				unitOpora.x = klePath[onPathNext][0] * kW + (kW/2.f);
				unitOpora.y = klePath[onPathNext][1] * kW + (kW/2.f);
				onPathNext +=1; //   

				vec2 vTmp;
				vTmp.x = klePath[onPathNext][0] * kW + (kW/2.f);
				vTmp.y = klePath[onPathNext][1] * kW + (kW/2.f);

				vTmp = vTmp - unitOpora;
				unitDir = normalize( vTmp);

				LenFull = length(vTmp);
			}
	}
	else //      ..
	{ //     -      .
		ox = unitOpora.x + unitDir.x * LenNow;
		oz = unitOpora.y + unitDir.y * LenNow;
	}
}










void Fgr::DrawForSelect()
{
	// - ,     LOD
	return;
}




int Fgr::NeedDraw()
{ //     .

	if( ! Active() ) return 0;


return 1; //     Draw
}








// -------


int Fgr::BanerSame( int anBanerID)
{
	if(anBanerID == baner) return baner;
	return 0;
}

int Fgr::on_SelMass_FilterUnit( int anBanerID)
{ //      - .
//         ?
	if( baner == anBanerID) return 1; else return 0;
return 1;
}














void Fgr::DoStrikeTry()
{
//    - -     .

	if(maxDmg < 1) return; //    .


	if( ! zn::ToZeroi( AnyAtakWait) ) return;
	//       .

// ...     .
//    ,     - 
//     ,      .



	if( fireTarg) //   
	{
	//	if( ! fireTarg->isMort) //    
	//	{
		//    ,     " ".
		//       .

			if( Sfer2D( ox, oz, rAtak, fireTarg->ox, fireTarg->oz, fireTarg->haf) )
			{
				if(nearToEnemy) {onPath =0; targPathKle =0;} // 

				DoStrike_( fireTarg); //   
			}
			else
				TrySetPathKle( fireTarg->ox, fireTarg->oz, 1); //   


			return;
	//	}
	//	else { fireTarg = 0; autoTarg = 0;}

	}




	if(autoTarg) //    ,   
	{
		if( Sfer2D( ox, oz, rAtak, autoTarg->ox, autoTarg->oz, autoTarg->haf) )
		{
			DoStrike_( autoTarg);
			return;
		}
		//     - -     .
	}


	autoTarg = WarSides.NearTarget( vec3(ox, 0.f, oz), rAtak, baner);
	if(autoTarg)
	{
		DoStrike_( autoTarg);
		//if(baner == BanerNeutral) {fireTarg = autoTarg;} // 
	}


//	if( ! autoTarg) //   
//	{
	//   -    -    -    
	// " "      ,       
	//       "  "
//	}


}









void Fgr::DoStrike_(Fgr* pf)
{
	if(!pf) return;

//    -    
//  .        
//      -    (    )
//   " ",   .
//         
//     " "  .


	AnyAtakWait = UdarWaitI; //   -

	// -------
	//          " "
	//   "       ".

	// ------
	vec3 staP; //   - 
	vec3 UdarP; //       " ".

	//   " ",     .
	staP = vec3(ox, 0, oz + haf/2.f); //  -    
	UdarP = vec3(pf->ox, 0, pf->oz); //   
	//Param_Damage_Anketa.pointBoom = UdarP;

	//VecEndEdit( staPoint, UdarP, 9.f); //  UdarP


		//        ..
	int anL = Fgrs.Add( fgrLaser, staP.x, staP.y, staP.z);
	if(anL)
	{
		Fgrs.m[anL].laserX = UdarP.x;
		Fgrs.m[anL].laserZ = UdarP.z;
		if(baner == 1)
			Fgrs.m[anL].uTex1 = texKosLaser;// = Wpn.FireTex;
		else Fgrs.m[anL].uTex1 = texNekLaser;
	}



	// ---    -
	// pf->SetUron( Rand2( minDmg, maxDmg), 0, OurExp, &Param_Damage_Anketa);

	int testBonus = 10; // 
	int anDmg = Rand2( minDmg, maxDmg);
	if(armKlv) anDmg *= armKlv;
	if(testBonus) anDmg *= testBonus;
	pf->SetUron( anDmg, 0, OurExp);

	//if( LevelUp(OurExp) ) { anOnLevelUp(this); }



	if( pf->isMort)
	{ //    -     -    
		fireTarg = 0;  autoTarg = 0;
	}
	else if( pf->baner != PlayerBanerID) //    ..
	{
		if( pf->baner != BanerNeutral) //      
		{
			//if( ! pf->autoTarg)
			if( ! pf->fireTarg) pf->fireTarg = this; // 
		}
		//   "" -  .. --.
	}

}









void Fgr::SetUron( int ironSum, int elSum, int& AtakerExp, int typeUron)
{
	if( isMort )
	{ //  " " -        .
		//      -    "-".
		return;
	}

	if( baner == BanerNeutral) //  
	{
		if( ! autoTarg)
		{
			rObserv = unitMaxRadAtak;
			rAtak = unitMaxRadAtak;
			//   -,     - .
		}
	}

//	switch(typeUron)
//	{
//	case x:  zn::AddToUp(ironSum,-11,1); break; //  
//	default:break;// -     "- "
//	}
//         this .
//	... masKle.getDefBonus( ox, oz); // klBonDefGood or klBonDefBad


	//       -   .
	// Fgrs.Add( fgrBoom, 0, 0, 0, &Param_Damage_Anketa);


#ifdef UNITS_TAKE_DAMAGE
	IronBar -= ironSum; if(IronBar<0) IronBar=0;
	ElecBar -= elSum;	if(ElecBar<0) ElecBar=0;
	if( !IronBar)// &&  !ElecBar)
	{ //     "" -      .
		isMort = 9000;//1; //9   
		uA = 155;
	}
#endif


	//int anL = Fgrs.Add( fgrHitUp, staP.x, staP.y, staP.z);
	//if(anL){Fgrs.m[anL].laserX = ironSum; Fgrs.m[anL].laserZ = elSum;}
	//    -    "  ".
	//       ,    
	//        -   .


	AtakerExp += 2; //  -  this 
		// "     "
}











void Fgr::KillDeadLinks()
{ //    

//    " ",   .
//        .
// ,  fireTarg & autoTarg     active.

	if(fireTarg) { if( ! fireTarg->status || ! fireTarg->active ) fireTarg = 0; }
	if(autoTarg) { if( ! autoTarg->status || ! autoTarg->active) autoTarg = 0; }

	if(activateFgr)
	{
		if( Fgrs.mOut(activateFgr) ) activateFgr = 0;
		else if( ! Fgrs.m[activateFgr].status ) activateFgr = 0;
	}

	// ...
}
















//     - ,  
//      ,   
//       ,   .
void Pult_CrtUni( Fgr* pF)
{
	int nek, tri;
			nek = Fgrs.Add( fgrUKosNorm, pF->ox, 0, pF->oz + KleW);
			Fgrs.SetBaner( nek, PlayerBanerID);  Fgrs.Deactive( nek);
			tri = Fgrs.Add( fgrTriger, pF->ox, 0, pF->oz);
			Fgrs.SetTrigerAct(tri, nek);
			Fgrs.SetBaner( tri, PlayerBanerID);

			//   ""     
			//     .
			//       ,   
			//   (child),   
}


void Pult_CrtKom( Fgr* pF)
{
	int nek, tri;
			nek = Fgrs.Add( fgrUKosKom1, pF->ox, 0, pF->oz + KleW);
			Fgrs.SetBaner( nek, PlayerBanerID);  Fgrs.Deactive( nek);
			tri = Fgrs.Add( fgrTriger, pF->ox, 0, pF->oz);
			Fgrs.SetTrigerAct(tri, nek);
			Fgrs.SetBaner( tri, PlayerBanerID);
}


void Pult_TehnolaX( Fgr* pF, int tehNom)
{
	int wt = Tehnola_Wait(tehNom);
	if(wt < 0) return; //  ,   -  .

	int tri = Fgrs.Add( fgrTriger, pF->ox, 0, pF->oz);

	Fgrs.SetTrigerExt(tri, tehNom, wt );
	Fgrs.SetBaner( tri, PlayerBanerID);
}








void PultUse_DomKosBunk( Fgr* pF, int Sig)
{
	if(!pF) return;
	int nek;

	if(Sig == 1) // 
	{ //       ,   
			//    (  -)
			//           ...
			nek = Fgrs.Add( fgrUKosBuilder, pF->ox, 0, pF->oz + KleW*2.f);
			Fgrs.SetBaner( nek, PlayerBanerID);
			//     ,    .
			testZ1.ReStart( 4, 0, 0.8f,   0.9f, 1.f, 10); //.
	}
	else if(Sig == 2) // 
	{
			nek = Fgrs.Add( fgrUKosRazved, pF->ox, 0, pF->oz + KleW*2.f);
			Fgrs.SetBaner( nek, PlayerBanerID);
	}

	else if(Sig == 4) //  ()
	{
		if( Tehnola_E( tehTestPeh, PlayerBanerID) )
		{
			if(PlayerEnergo >= 500)
			{
				PlayerEnergo = WarSides.ResEnergo( PlayerBanerID, -500);
				Pult_CrtUni( pF);
			}
		}
	}
	else if(Sig == 5) // 
	{
		if(PlayerGem1 >= 3)
		{
			PlayerGem1 = WarSides.ResGem1( PlayerBanerID, -3);
			Pult_CrtKom( pF);
		}
	}

	else if(Sig == 10) //  
	{
		//         .
		if( ! Tehnola_E( tehTestPeh, PlayerBanerID) )
			Pult_TehnolaX( pF, tehTestPeh);
	}
	else if(Sig == 11) //  -
	{
		if( ! Tehnola_E( tehTestElGen, PlayerBanerID) )
			Pult_TehnolaX( pF, tehTestElGen);
	}

}



void PultUse_DomKosKaz( Fgr* pF, int Sig)
{
	if(!pF) return;
	int nek, tri;
		if(Sig == 1) // 
		{
			Pult_CrtUni( pF);
		}
		else if(Sig == 2) // 
		{
			Pult_CrtKom( pF);
		}
}



void PultUse_UKosBuilder( Fgr* pF, int Sig)
{
	if(!pF) return;

	int tri;
	Fgr* nF =0;

		if(SigAbTail) //   
		{
			if(Sig < 10)//    
			{
				SigAbTail = 0; //  
				//    " "
			}
			else if(Sig == 101) //  -
			{
				// ,   ..
				//    -     
				//   -      
				//  - -     -   
				//   --,     -.

				//  ,      .
				//    ... //   " -"
				if( Sfer2D(SigAbTail_x, SigAbTail_z, 1.f, pF->ox, pF->oz, pF->rAtak) )
				{
					nF = Fgrs.Add_( fgrDomKosEner, SigAbTail_x, 0, SigAbTail_z);
					nF->baner = PlayerBanerID;
					//pF->TrySetFire( nF);    -
					//         ...
				}

			}
			else if(Sig == 102) // 
			{
				tri = masKle.Kle_FromXZ( SigAbTail_x, SigAbTail_z);
				if(tri != -1)
				{

				if( Fgrs.FindAnyIn( fgrPultFlag, pF->baner,
						masKle.m[tri].tx, masKle.m[tri].tz, KleW, KleW) )
				{
					if( Sfer2D(SigAbTail_x, SigAbTail_z, 1.f, pF->ox, pF->oz, pF->rAtak) )
					{
					//masKle.XZ_FromKle(SigAbTail_x, SigAbTail_z, tri, 1);
					//nF = Fgrs.Add_( fgrDomKosPost, SigAbTail_x, 0, SigAbTail_z);
					nF = Fgrs.Add_( fgrDomKosPost,
						masKle.m[tri].tx + 1.f, 0, masKle.m[tri].tz + KleW - 1.f);
							// +1  -1       .
					nF->baner = PlayerBanerID;
					//pF->TrySetFire( nF);
					}
				}

				}
			}

			SigAbTail = 0;


		}
		else if(Sig == 1) //  -
		{
			SigAbTail = 1; //  - ,   
			SigAbTail_fgr = pF; //      
		}
		else if(Sig == 2) //   
		{
			SigAbTail = 2;
			SigAbTail_fgr = pF;
		}
}



//   "  "   ,
//       PultUse_UKosBuilder
void PultUse_UKosKom1( Fgr* pF, int Sig)
{
	if(!pF) return;

		if(Sig == 1)
		{
			RTab_WndUnit_On();
		}
		else if(Sig == 2)
		{
			RTab_WndUnit_On();
		}
		else if(Sig == 3)
		{
			RTab_WndUnit_On();
		}
}







void UnitUsePult( Fgr* pF)
{
	if(!pF) return;
// ..
//   ,     fromPultSig.
//  ,         
//   -    ...     
//       ,     
//  ,     "  ".
//           
//           
//   -           
//   "" ...
// ,     " -"  , 
//       .   
//          .



	switch(pF->status) //- - 
	{
	case fgrDomKosBunk: PultUse_DomKosBunk( pF, pF->fromPultSig); break;
	case fgrDomKosKaz:  PultUse_DomKosKaz( pF, pF->fromPultSig); break;
	case fgrUKosBuilder: PultUse_UKosBuilder( pF, pF->fromPultSig); break;
	case fgrUKosKom1:   PultUse_UKosKom1( pF, pF->fromPultSig); break;

	default: break;
	}
}













void Fgrs_clearAll() { Fgrs.clearAll(); }





void PoleKlik_RingDekor( float rx, float rz, float rad)
{
	return;
//     -      ,
//     .
}







// ------      ..

void StaMutBuker( int flag, float x, float z)
{ //     ,       .

	//PlayerBanerID = 
	//PlayerBanerID +1 =  
	int n = Fgrs.Add( fgrDomKosBunk, x, 0, z);
	Fgrs.SetBaner( n, flag);
}


void StaMutKExpa( float x, float z)
{//
	Fgr* xF = Fgrs.Add_( fgrDomKosEner, x, 0, z);
	xF->baner = 0; //-    -, 
}

void StaMutXSki( float x, float z)
{//--
	Fgr* xF = Fgrs.Add_( fgrDomKosEner, x, 0, z);
	xF->baner = 0; //-    -, 
}


void StaMutBoxExpa( float x, float z)
{//-  
	Fgr* xF = Fgrs.Add_( fgrDomKosEner, x, 0, z);
	xF->baner = 0; //-    -, 
}

void StaMutBoxGem( float x, float z)
{//  -   
	Fgr* xF = Fgrs.Add_( fgrDomKosEner, x, 0, z);
	xF->baner = 0; //-    -, 
}

void StaMutBoxU1( int u, float x, float z)
{//  

	// 1 = 
	// 2 = 
	int n;
	if(u == 1)
		{n = Fgrs.Add( fgrUNekLom, x, 0, z); Fgrs.SetBaner( n, BanerNeutral);}
	else
		{n = Fgrs.Add( fgrUNekKrwser, x, 0, z); Fgrs.SetBaner( n, BanerNeutral);}
}







