// Fint_zn.h
// -----
//  bf1_zn.h
//     ,   "-".
//     Fint_zn, - BaseForce1 .


#ifndef FintZn_INCLUDED
#define FintZn_INCLUDED
//{

	// ---
	// zn::Tram( ... )

	const int TramRub1 = 1; // not work;   signal on low
	const int TramRub2 = 2; // not work;   signal on hi
	const int TramRub3 = 3; // hi not work;  trig on low
	const int TramRub4 = 4; // low not work; trig on hi
	const int TramRub5 = 5; //  work all;    trig on low
	const int TramRub6 = 6; //  work all;    trig on hi


// --- Gen HINT ..
// -      
//      .
//        - 
//   ,        ...


	// ---
	// ring <<= 2; // ring *= 4;  ring     - -




	// -----
	//  Fint1.h    -    bf1_zn

class t_FintFloat
{
private:
	//t_Mej mj;
	UINT mj_OldMilli, mj_Interval;
	float MinZna, MaxZna; //, PribZna;
	int ToggleM, PlusPrib, Upor;


	 // skolko   .
	// gMilli    GetTickCount()
	//   1     .
	int mj_aTry(float& skolko, int gMilli);






public:
	float _ResFlo, PribZna;
	int CountLoops;


	t_FintFloat()
	{
		_ResFlo = 0.0f; CountLoops=0; Upor = -1;
		mj_OldMilli = 0;//       .
		mj_Interval = 1000;
	}

	t_FintFloat(float zna, float min, float max, float prib, int toggleMode=0, UINT interval=500)
	{
		Init(zna, min, max, prib, toggleMode, interval);
	}
	//~t_FintFloat(){return;}




		//      Off()
//	void Default( int nom=0 )
//	{
//		if(nom==0) Off();
//		else		FintFloat_DefPreset(this, nom);
//	}

	inline void Off() {_ResFlo = 0.0f; CountLoops=0; Upor = -1;}

	inline float GetMin() {return MinZna;}
	inline float GetMax() {return MaxZna;}

	inline int GetTogMode() {return ToggleM;}
	inline int GetInterval() {return (int)mj_Interval;}

	inline int GetPrib() {return PlusPrib;}

		//  1,      ,   
	inline int GetUpor() {if(Upor == 1) return 1; else return 0;}

	inline int ClearUpor() //   ToggleM == 1 (    -)
	{
		if(Upor == -1) return 0; Upor = 0; return 1;
	}



	void Init(float zna, float min, float max,  float prib, int toggleMode=0, UINT interval=500);

	float _Update();


}; //class t_FintFloat
















class zn
{
public:
	// {


	//  - "" hafEmpty     AN    
	// MidBall( Lift as 30, 10, 0.5f); // Res Lift as 10
	// MidBall( Lift as -5, 10, 0.5f); // Res Lift as 0
	// MidBall( Lift as -24, 10, 0.5f); // Res Lift as -7
static void MidBall( int& an, int hafEmpty, float zoom)
{
	if(an==0) return;
	Abs(hafEmpty);
	if( ! Outi( an, -hafEmpty, hafEmpty) ) {an=0; return;}

	if(an > 0)		an -= hafEmpty;// 20
	else if(an < 0)	an += hafEmpty;

	//an = i_floor( float(an) * zoom ); -  -   
	float t = float(an) * zoom;
	an = int(t);
}




	// Absf(-0.5f) = 0.5f  //  
	// Absf(0.5f) = 0.5f //   -,   
	//   
static inline float Absf( float a)  { if(a < 0.f) a = -(a);   return a; }
static inline int   Absi( int a)    { if(a < 0) a = -(a);   return a; }

// ---------------------
static inline void Abs( float& a)  { if(a < 0.f) a = -(a); }
static inline void Abs( int& a)   { if(a < 0) a = -(a); }

static inline int res1( float src, float& clon) { clon = src;  return 1; }
static inline int res1(   int src, int& clon)   { clon = src;  return 1; }

static inline int res1( float src, float& clon, float& clon2) { clon2 = clon = src;  return 1; }
static inline int res1(   int src, int& clon, int& clon2)   { clon2 = clon = src;  return 1; }



static int ToDn( float& z, float roof)
{
	// "to" is spec keyword //zero on proc begin // non zero if been use
	// if(roof < z)  roof to z;  return to;

	if(roof < z) return res1(roof, z);   return 0;
	//if(roof < z) {z = roof;  return 1;}   return 0;
}

// ToUnderRoof
static int ToDn( int& z, int roof)
{
	if(roof < z) {z = roof;  return 1;}   return 0;
}





static int ToUp( float& z, float floor)
{	if(floor > z) {z = floor;  return 1;}   return 0;
}

// UpToFloor
static int ToUp( int& z, int floor)
{	if(floor > z) {z = floor;  return 1;}   return 0;
}
//-------------------


/*
static int Outf( float m, float z, float M)
{
	if((z < m) || (z > M)) return 1;
return 0;
}
static int Outxf( float a, float z, float b)
{
	if(a < b){  if((z < a) || (z > b)) return 1;  }
	else	{  if((z < b) || (z > a)) return 1;  }
return 0;
}

	// Outi( 24, 24, 34) = false
	// Outi( 24, 19, 34) = true
static int Outi( int m, int z, int M)
{
	if((z < m) || (z > M)) return 1;
return 0;
}
static int Outxi( int a, int z, int b)
{
	if(a < b){  if((z < a) || (z > b)) return 1;  }
	else	{  if((z < b) || (z > a)) return 1;  }
return 0;
}
*/


/*
//  MIN  -   -  
//   Outxf  - MIN  MAX   ...
static inline int Outf( float z, float m, float M)  { if((z < m) || (z > M)) return 1;  return 0;}
static inline int Outxf( float z, float a, float b)
{
	if(a < b){  if((z < a) || (z > b)) return 1;  }
	else	{  if((z < b) || (z > a)) return 1;  }
return 0;
}

	// Outi( 24, min 24, max 34) = 0
	// Outi( 19, min 24, max 34) = 1
	// Outi( 35, min 24, max 34) = 2
static inline int Outi( int z, int m, int M)  { if((z < m) || (z > M)) return 1;  return 0;}
static inline int Outxi( int z, int a, int b)
{
	if(a < b){  if((z < a) || (z > b)) return 1;  }
	else	{  if((z < b) || (z > a)) return 1;  }
return 0;
}
*/


//  min  -   -  
//   Outxf  - min  MAX   ...
//  1,    min;  2    MAX
static inline int Outf( float z, float m, float M) { if(z < m) return 1;  if(z > M) return 2;  return 0;}
static inline int Outxf( float z, float a, float b)
{	if(a < b) return Outf( z, a, b); else return Outf( z, b, a);
}

	// Outi( 24, min 24, max 34) --> 0
	// Outi( 19, min 24, max 34) --> 1
	// Outi( 35, min 24, max 34) --> 2
static inline int Outi( int z, int m, int M) { if(z < m) return 1;  if(z > M) return 2;  return 0; }
static inline int Outxi( int z, int a, int b)
{	if(a < b) return Outi( z, a, b); else return Outi( z, b, a);
}








	// x        a & b .
static int OutOnRingf( float x,  float a, float b, float ring)
{
	float r2 = ring / 2.f;

	if( (a < 0.f) &&(x > r2) )
	{
		if(  (x > b) &&(x > Ring1f(a, ring))  ) return 0;   else return 1; //1 as out
	}

	if( (b > ring) &&(x < r2) )
	{
		if(  (x < a) &&(x < Ring1f(b, ring))  ) return 0;   else return 1; // 1 as out
	}

	if((x < a) || (x > b)) return 1; //out
return 0;
}


	// x        a & b .
static int OutOnRingi( int x,  int a, int b, int ring)
{
	int r2 = ring / 2;

	//  10 20 30   .
	//  -10 20 30  .

	//  -10 355 30 ...    
	if( (a < 0) &&(x > r2) )
	{
		if(  (x > b) &&(x > Ring1i(a, ring))  ) return 0;   else return 1;
	}

	// 330 185 370
	// 330  5  370 ...  
	if( (b > ring) &&(x < r2) )
	{
		if(  (x < a) &&(x < Ring1i(b, ring))  ) return 0;   else return 1;
	}

	if((x < a) || (x > b)) return 1;
return 0;
}



//static inline int InerMi( int* xmM)
//{ return(  (xmM[0] > xmM[1]) &&(xmM[0] < xmM[2]) ? 1 : 0  ); }

//static inline int InerMf( float* xmM)
//{ return(  (xmM[0] > xmM[1]) &&(xmM[0] < xmM[2]) ? 1 : 0  ); }


//static int InerMi( int x, int min, int max)  { if(  (x > min) &&(x < max)  ) return 1;  return 0; }
static inline int InerMi( int x, int min, int max)  { return(  (x > min) &&(x < max) ? 1 : 0  ); }
//static int Ineri( int x, int ofsX, int range)
//{ if(  (x > ofsX) &&(x <  ofsX + range)  ) return 1;  return 0;}

static inline int InerMf( float x, float min, float max) {return(  (x > min) &&(x < max) ? 1 : 0  );}


	// 24 --> 30 <-- 34
	// INi( 30, 24, 10) = true
	// INi( 24, 24, 10) = false
static inline int Ineri( int x, int ofsX, int range) {return( (x > ofsX) &&(x <  ofsX + range) ? 1 : 0 );}

//static int INi( int x, int ofsX, int range)
//static int Ineri( int x, int ofsX, int range)
//{ if(  (x > ofsX) &&(x < (ofsX + range))  ) return 1;  return 0;}


//static int INf( float x, float ofsX, float range)
static int Inerf( float x, float ofsX, float range)
{
	if(  (x > ofsX) &&(x < (ofsX + range))  ) return 1;
return 0;
}






//static float FloMod( float i1, float i2)
static inline float fMod( float i1, float i2);// { return fmodf( i1, i2); } //  include/math.h

//static float FloIntMod( int i1, int i2) { return float( i1 % i2 ); }
//static float FloModi( int i1, int i2) { return float( i1 % i2 ); }
static inline float fModi( int i1, int i2) { return float( i1 % i2 ); }

//          
//      i or f
// fRead //   Float
// fReadf //         
// AnProcf //  void    ,    Float
// -----  -    ,  overload -
// -   -     int& ,   , 
//  2.f     2     int-version    ...
// -----  -       ...




static int ModTms( int i1, int ring)
{
	return Absi( i1 / ring);
}

	// "a1"       "ring"
static void ModRing( float& a1, float ring)
{
	Abs( ring);

	// 721.5 - (355.5 * 2) = 10.5

	if(      a1 < 0.f)   { a1 += ring * float( ModTms((int)a1, (int)ring)+1 ); }
	else if( a1 > ring) { a1 -= ring * float( ModTms((int)a1, (int)ring)   ); }
}

	// fGetFrom(0.5,   0, 2) = 1
	// (0.18, 0, 2 ) = 0.36
	// (0.18,  2, 0) = 1.64
//static float FloGetFrom( float drob, float min, float maxZna)
static float fGetFrom( float drob, float min, float maxZna)
{
	if(min > maxZna) { float tFlo = min - maxZna;   return tFlo - (tFlo * drob); }
 return (maxZna - min) * drob;
}


// linear interpolation
static inline int iLerp( const int x, const int range, const float fRatio)
{
//    -    
       if( fRatio==0) return x;
  else if( fRatio==1) return x + range;// -1;  // return x1;
  //else return x + ((x1-x) * fRatio);
  else return int(x + (range * fRatio)); // (range-1) * fRatio
}

static inline float fLerp( float f0, float f1, float fFactor)
{ return f0 + ((f1-f0) * fFactor); }






static inline void Perc( float probegNow, float probegFull, float anBank,
						 float& probegPerc, float& partBank)
{
	if(probegFull==0){probegPerc=0; partBank=0; return;}
//	probegPerc = probegNow / (probegFull / 100.f);
//	partBank = probegPerc / 100.f * anBank;
probegPerc = probegNow / probegFull;
partBank = probegPerc * anBank;
probegPerc *= 100.f;
}

static inline float Perc( float probegNow, float probegFull)
{
	if(probegFull==0){return 0;}
	return (probegNow / probegFull) * 100.f;
}

	// void Perc( Now, Full, 1.f, float&, float&) //      .
	//     (Now / Full).
	// ---
	// float Perc( probegNow, probegFull) //   .
	// ---
	// float Perc( probegNow, probegFull, anBank) //  
	// bonus = Perc( 60, 132, 125) // 56.8181f //  45.454    125
static inline float Perc( float probegNow, float probegFull, float anBank)
{
	if(probegFull==0){return 0;}
	//return (probegNow / (probegFull/100.f)) / 100.f * anBank;
	return (probegNow / probegFull) * anBank;
}

	//     (34) 125 ,     12 
	//       125   12 ...
	// -        ".  "(0.34)
	// bonus = Perc2( 12.f, 0.34f, 125) // 44.117f
static inline float Perc2( float probegNow, float oneperc, float anBank)
{
	if(oneperc==0){return 0;}
//return (probegNow / oneperc) / 100.f * anBank;
return probegNow / (oneperc * 100.f) * anBank;
}






static float Mid( float flo1, float flo2 )
{
	if( flo1 < flo2) { return  flo1 + ((flo2 - flo1) * 0.5f); }

return  flo2 + ((flo1 - flo2) * 0.5f);
}






static void Add( int& an, int addZna,  int* min, int* max )
{// 6
	an += (addZna);
	if(min){if(an < min[0]) an = min[0];}
	if(max){if(an > max[0]) an = max[0];}
}


static void Add( int& an, int addZna,  int min, int max )
{// 5
	an += (addZna);
	if(an < min) an = min;
	if(an > max) an = max;
}


static void Add( float& an, float addZna,  float min, float  maxFlo )
{// 4
	an += (addZna);
	if(an < min) an = min;
	if(an > maxFlo) an = maxFlo;
}


static void Add( float& an0_1, float addZna)
{// 3
	an0_1 += (addZna);
	if(an0_1 < 0.f) an0_1 = 0.f;
	else if(an0_1 > 1.f) an0_1 = 1.f;
}


static void Add( float& an, float addZna, float ring)
{// 2
	// Abs(ring);
	an += (addZna);
	if(an < 0.f) an += ring;
	if(an > ring) an -= ring;
}

	//   iAdd( int an, int prib, int min, int max)
	//   fAdd( float an, float prib, flo min, flo max)
	// ++++
	// 6. Add( int1, prib, &min or NULL, &max or NULL)
	// ---
	// 5. zn::Add( anInt,  (gMX < anMenu_HalfVert)? -1:1,   0, 5);
	// Add( int1, prib, min, max)
	// ---
	// 4. Add( flo, prib, min, max)
	// ---
	// 3. Add( flo0_1, prib) //     
	// ---
	// 2. Add( flo, prib, F360)  // 10 + (-20) = 350
	// ---
	// 1. Add( int, prib, 50)  // 10 + (-20) = 40
static void Add( int& an, int addZna, int ring)
{// 1
	an += (addZna);
	if(an < 0) an += ring;
	if(an > ring) an -= ring;
}




static int iAdd( int an, int addZna,  int min, int max )
{// i5
	an += (addZna);
	if(an < min) an = min;
	if(an > max) an = max;
	return an;
}
static float fAdd( float an, float addZna,  float min, float  maxFlo )
{// f4
	an += (addZna);
	if(an < min) an = min;
	if(an > maxFlo) an = maxFlo;
	return an;
}





static inline void AddToUp(float& z, float addZna, float floor=0.f)
{
	z += (addZna);  ToUp( z, floor);
}

//     floor // AddToUp( an2, -5) //an2  an0
static inline void AddToUp(int& z, int addZna, int floor=0)
{
	z += (addZna);  ToUp( z, floor);
}



static inline void AddToDn(float& z, float addZna, float roof)
{
	z += (addZna);  ToDn( z, roof);
}

//  - roof
static inline void AddToDn(int& z, int addZna, int roof)
{
	z += (addZna);  ToDn( z, roof);
}








static void Addw( float& an, float prib, float min, float maxZna )
{// 3
	if(min > maxZna) return;
	if(prib > (maxZna - min)) return;
	an += (prib);

	if( an > maxZna) an -= (maxZna - min);
	else if( an < min) an += (maxZna - min);
}


static void Addw( int& an, int prib, int min, int maxZna )
{// 2
	if(min >= maxZna) return;
	an += (prib);
																//  =  + 1
	if( an > maxZna) an = min +       (  (an-min) %      ((maxZna - min)+1)  );
	else if( an < min) an = maxZna + (  (an-maxZna) % ((maxZna - min)+1)  );
}

	// 3. Wrap AddWarp( anFlo, -0.1f,  0.f, 2.f ); // if anFlo as 0 (1.9 to anFlo)
	// Wrap AddWarp( anFlo, 0.5f,  2.5f, 7.f ); // if anFlo as 0 (5 to anFlo)
	// ---
	// 2.     ,    1,,7  .
	//    1,,7   8   1 ...
	// ---
	// 1.     ""    ... z min max
static void Addw( int* an, int prib)
{// 1
	if(an[1] >= an[2]) return;
	an[0] += (prib);
																	//  =  + 1
	if( an[0] > an[2]) an[0] = an[1] +       (  (an[0]-an[1]) %      ((an[2] - an[1])+1)  );
	else if( an[0] < an[1]) an[0] = an[2] + (  (an[0]-an[2]) % ((an[2] - an[1])+1)  );
}


/*  -  " "
static void Addw2( float* an, float prib, float min, float maxZna )
{
// ,  "    "  - NULL ...
	if( ! an) return;
	if(min > maxZna) return;
	an[0] += (prib);

	if( an[0] > maxZna) an[0] -= (maxZna - min);
	else if( an[0] < min) an[0] += (maxZna - min);
}
*/





	// res1   -     //  1  (klv as 1)
	// resDop as 2 &&(res1 as 1)        ()
	// resDop as 2 &&(res1 as 2)        .
	// zn::Lines( _2, _4, 11, 7 );
	// zn::Lines( _3, _1, 15, 7 );
static void Lines( int& res1, int& resDop, int klv, int klvInLine )
{
	if( ! klvInLine) klvInLine=1;

	res1 = klv / klvInLine;
	resDop = klv % klvInLine;
	if(resDop) res1 += 1;
}





	// -+- -+- -+- -+- -+-


static int Ring1i( int an, int range )
{
	// Abs( range);
	if(an < 0) an += range;   else if(an > range) an -= range;
return an;
}

static float Ring1f( float an, float range )
{
	if(an < 0.f) an += range;   else if(an > range) an -= range;
return an;
}

	// (2) kruF2 = zn::Ring1f( kruFlo, radRing, -2.f);  ???


	// (3) return Ring1i( 90 + (range360 * -0.5f), range360); // = 270
static int Ring1i( int src, int range, float plusPart )
{  return Ring1i( int(src + (float(range) * plusPart)), int(range));
}
static float Ring1f( float src, float range, float plusPart )
{  return Ring1f( src + (range * plusPart), range);
}


static int Ring1( int& an, int range )
{
	if( an < 0 )  return res1( an + range, an);
	//if( an < 0 )  {  an += range;  return 1;}
	if( an > range ) { an -= range;  return 1;}
return 0;
}

static int Ring1( float& an, float range )
{
	if( an < 0.f )  {  an += range;  return 1;}
	if( an > range ) { an -= range;  return 1;}
return 0;
}


static void Ring2( int& an, int range )
{
	for(int i=0; i<8; i++){ if( ! Ring1( an, range) ) return; }
}
static void Ring2( float& an, float range )
{
	for(int i=0; i<8; i++){ if( ! Ring1( an, range) ) return; }
}






//static float FloTram( float nowf, float min, float maxFlo )
static float fTram( float nowf, float min, float maxFlo )
{
	if(nowf < min) nowf = min;
	if(nowf > maxFlo) nowf = maxFlo;
return nowf;
}

//static int IntTram( int now, int min, int max )
static int iTram( int now, int min, int max )
{
	if(now < min) now = min;
	if(now > max) now = max;
return now;
}




static inline void Swap( float& f1, float& f2) { float t1=f1; f1=f2; f2=t1;}
static inline void Swap( int& f1, int& f2)     { int t1=f1;    f1=f2; f2=t1;}

static int Rep( int& an, int newZna)
{
	int temp = an;
	an = newZna;
	return temp;
}

	// Get return Curr & Replace with newZna
static float Rep( float& an, float newZna)
{
	float temp = an;
	an = newZna;
	return temp;
}

// -----
//    TramKonus,     
// - -    ...
//       TramR      ...
//  -    ...


	// anBOOL = TramRep( anInt as 7, -5, 5, 0); // anBOOL =1;  anInt =0;
static int TramRep( int& an, int m, int M, int ifOut)
{
	if((an < m) || (an > M)) {an = ifOut; return 1;}  return 0;
}




static inline int TramHi( int& an, int maxZna )
{
	if( an > maxZna )  {  an = maxZna;  return 1;}  return 0;
}

static inline int TramLow( int& an, int min)
{
	if( an < min )  {  an = min;  return 1;}  return 0;
}

static inline int TramHi( float& an, float maxZna )
{
	if( an > maxZna )  {  an = maxZna;  return 1;}  return 0;
}

static inline int TramLow( float& an, float min)
{
	if( an < min )  {  an = min;  return 1;}  return 0;
}



static int Tram( int* an)
{	if( an[0] < an[1] )  {  an[0] = an[1];  return 1;}
	if( an[0] > an[2] )  {  an[0] = an[2];  return 1;}
return 0;
}

static int Tram( float* an)
{	if( an[0] < an[1] )  {  an[0] = an[1];  return 1;}
	if( an[0] > an[2] )  {  an[0] = an[2];  return 1;}
return 0;
}




static int Tram( int& an, int min, int maxZna )
{
	if( an < min )  {  an = min;  return 1;}
	if( an > maxZna )  {  an = maxZna;  return 1;}
return 0; // -
}

static int Tram( float& an, float min, float maxZna )
{
	if( an < min )  {  an = min;  return 1;}
	if( an > maxZna )  {  an = maxZna;  return 1;}
return 0;
}


static int Tram( int& an, int min, int maxZna,  int flagRub )
{
	switch(flagRub)
	{
	case TramRub1:  if( an < min )     return 1;		break;
	case TramRub2:  if( an > maxZna )  return 1;		break;
	case TramRub3:  if( an < min )    return res1(min, an);  break;
	case TramRub4:  if( an > maxZna ) return res1(maxZna, an); break;

	case TramRub5:
			if( an < min ) return res1(min, an);
			if( an > maxZna ) an = maxZna;
		break;
	case TramRub6:
			if( an > maxZna ) return res1(maxZna, an);
			if( an < min )  an = min;
		break;
	default:
		break;
	}
return 0; // -
}


static int Tram( float& an, float min, float maxZna,  int flagRub )
{
	switch(flagRub) //  Tram( int& an, int min, int maxZna,  int flagRub )
	{
	case TramRub1:  if( an < min )  return 1;
		break;
	case TramRub2:  if( an > maxZna )  return 1;
		break;
	case TramRub3:  if( an < min ) { an = min; return 1;}
		break;
	case TramRub4:  if( an > maxZna ) { an = maxZna; return 1;}
		break;
	case TramRub5:
			if( an < min ) {  an = min;  return 1;}
			if( an > maxZna ) an = maxZna;
		break;
	case TramRub6:
			if( an > maxZna ) {  an = maxZna;  return 1;}
			if( an < min )  an = min;
		break;
	default:
		break;
	}
return 0;
}







	// -+- -+- -+- -+- -+-


	//  1,     ( 0 , , 255 )
static int In_BYTE( int z )
{
	if((z < 0) || (z > 255)) return 0;
return 1;
}	// bit = 0 or 1
	// BYTE = unsigned char = 8 bit
	//--------

	//  1,     ( -32768 , , 32767 )
static int In_short( int z )
{
	if((z > 32767) || (z < (-32768))) return 0;
return 1;
}	// short = 2 BYTE = 16 bit
	//       32767   
	//--------

	//  1,     ( 0 , , 65535 )
static int In_WORD( int z )
{
	if((z < 0) || (z > 65535)) return 0;
return 1;
}	// WORD = unsigned short = 16 bit
	// 256 * 256 = 65536  //       65535  
	//--------


		//  (1 or 0)     
	//static int SwapFlag( int& an )
	static int FlagSwap( int& an )
	{
	//	if(an > 0) {an = 0; return 0;}  else an = 1;
	//return 1;
		//if(an < 1) return res1(1, an); // return an =1;
		if(an < 1) return an =1;
	return an =0;
	}



	// -+- -+- -+- -+- -+-


static float FrT( float xFlo);


	// zn::Add( flo, zn::FrT( 0.01f, GlobFrameTime), min, max );
	// lastFrMLL     -.
static float FrT( float xFlo, int& lastFrMLL)
{
	if( lastFrMLL < 2) return xFlo;
return xFlo * float( lastFrMLL);
}



static float FrT_abs( float xFlo, int& lastFrMLL)
{
	if( lastFrMLL < 2) return Absf( xFlo);
return Absf( xFlo * float( lastFrMLL) );
}

	//   
static float FrT_abs( float xFlo);



static float FrT_odd( float xFlo);


	//FrT_odd( float xFlo) //  
	// ---
	// ExtraMLL   " "  - "".
	// (   ,       )
static float FrT_odd( float xFlo, int& lastFrMLL, int ExtraMLL)
{
	ExtraMLL += lastFrMLL;
	if( ExtraMLL < 2) return xFlo;

return xFlo * float( ExtraMLL);
}




/*
   .
    -  .
    -,      ::GFrameTime
    -      .

	//        -.
	// GFGameTime = GFrameTime * o2::GSpOfGame;
static float FrTG( float xFlo)
{
	if( ::GFGameTime < 2) return xFlo;
return xFlo * float( ::GFGameTime);
}

static float FrTG_abs( float xFlo)
{
	if( ::GFGameTime < 2) return Absf( xFlo);
return Absf( xFlo * float( ::GFGameTime) );
}

	//   
static float FrTG_odd( float xFlo)
{
	int ExtraMLL = ::GFGameTime + ::GFGameTimePred;
	if( ExtraMLL < 2) return xFlo;

return xFlo * float( ExtraMLL);
}
*/








static void ToZero( int& anMLL, int& lastFrMLL)
{	if( anMLL > 0 ) { anMLL -= lastFrMLL;   if(anMLL < 1) anMLL = 0; }
}
//     .
static void ToZero( int& anMLL);



//     FrT
//     ID_Call
// (      -    ID_Call)
//  ,            .
static void ToZeroID( int& anMLL, int ID_Call);



static int ToZeroi( int& anMLL, int lastFrMLL)
{	if( anMLL > 0 ) { anMLL -= lastFrMLL;  if(anMLL < 1) return res1(0, anMLL); }
	else return 1;
return 0;
}
	//  1,  anMLL      
	//static int ToZeroi( int& anMLL, int replaceFrMLL=0)
static int ToZeroi( int& anMLL);

/*
// if( zn::ToZeroTrig( waitSteps, 1, newSteps  ) ) an22 = 15;
static int ToZeroTrig( int& intervalMLL, int lastFrMLL, int intervalSrc, int needRise=1 )
{
	if( ToZeroi( intervalMLL, lastFrMLL) )
	{
		if( needRise) intervalMLL = intervalSrc;
		return 1;
	}
return 0;
}
*/

static int ToZeroTrig1( int& intervalMLL)
{
	if( intervalMLL < 1) return 0;
	if( ToZeroi( intervalMLL) ) return 1;
return 0;
}

/*
	//  intervalMLL ,   -       
static int ToZeroTrig1( int& intervalMLL, int lastFrMLL, int intervalSrc, int needRise=1 )
{
	if( intervalMLL < 1) return 0;
	if( ToZeroi( intervalMLL, lastFrMLL) )
	{
		if( needRise) intervalMLL = intervalSrc;
		return 1;
	}
return 0;
}
*/



//anProb(...)
//{
//	static const int ivalsrc = 250;
//	static int ival = ivalsrc;
//
//	zn::ToZero(ival, frameMLL);
//	// if( zn::ToZeroTrig( ival, frameMLL, ivalsrc, int needRise=1)) //    
//	// if( zn::ToZeroLap( ival, frameMLL, ivalsrc, &holdCount)) //    
//	if( ! ival)	{  ival = ivalsrc;
//		...
//	}
//}
//void anProb2()
//{
//	if( zn::ToZeroi( Wait1)) //   Wait1   flo1
//	{	if( zn::ToZeroTrig( ival, ::GFrameTime)) //, ivalsrc))
//		{ ival = ivalsrc; //   
//			if(prib > 0)  tmp = zn::Climb2(flo1, prib, 50, 1);
//				else	tmp = zn::Climb2(flo1, prib, 0, 1);
//			if(tmp) {prib = -prib;  Wait1 = Wait1src;}
//		}  // flo1   ,      -
//	}
//}


	//     (t1, t2, t3)
	//  , , -
	//    TimeMSM( TimeFromLevelBegin, GUIxxMin, GUIxxSec, GUIxxMil);
static void TimeMSM(int TimeMLL, int& t1, int& t2, int& t3);






	// -+- -+- -+- -+- -+- // $$$$$$$$$



static int IntClimbi( int z, int prib, int piv, int haf)
{
	Abs( haf); // if( haf < 0) haf = - haf;
	Abs( prib); // if( prib < 0) prib = - prib;
	//      ,      .
	if( Outi( z,  piv - haf,   piv + haf ) )
	{
		if( PribProvPivBi( z, prib, piv) ) return piv;
		else if( Outi( z,  piv - haf,    piv + haf ) ) return z;
	}
return piv;
}

//static float FloClimbf( float z, float prib, float piv, float haf)
static float fClimbf( float z, float prib, float piv, float haf)
{
	Abs( haf);   Abs( prib);

	if( Outf(   z, piv - haf,  piv + haf ) )
	{
		if( PribProvPivB( z, prib, piv) ) return piv;
		else if( Outf(  z, piv - haf,  piv + haf ) ) return z;
	}
return piv;
}

static void IntClimb( int& upd, int prib, int piv, int haf)
{	upd = IntClimbi( upd, prib, piv, haf);
}
//static void FloClimb( float& upd, float prib, float piv, float haf)
static void Climbf( float& upd, float prib, float piv, float haf)
{	upd = fClimbf( upd, prib, piv, haf);
}


static float FloToZon( float z, float prib, float piv, float haf)
{
	Abs( haf);   Abs( prib);
	//    ,      
	//if( Outf(   z, piv - haf,  piv + haf ) )  PribProvPiv( z, prib, piv);
	if( Outf(   z, piv - haf,  piv + haf ) )
	{
		if( z > piv )  z -= prib;   else if( z < piv )  z += prib;
	}
return z;
}

static int IntToZon( int z, int prib, int piv, int haf)
{
	Abs( haf);   Abs( prib);

	if( Outi(   z,  piv - haf,  piv + haf ) )
	{
		if( z > piv )  z -= prib;   else if( z < piv )  z += prib;
	}
return z;
}


static int Climb( float& res, float z, float prib, float piv, float haf )
{
	//        
	Abs( haf);   Abs( prib);

	if( Outf(   z, piv - haf,  piv + haf ) ) // -   
	{
		if( ! PribProvPivB( z, prib, piv) )
		{
			//  - -,
			//        ...
			if( Outf(   z,  piv - haf,  piv + haf ) )  {res = z; return 0;} //   
		}
	}

	res = piv;
return 1;
}

static int Climb( int& res, int z, int prib, int piv, int haf )
{
	Abs( haf);   Abs( prib);

	if( Outi(   z, piv - haf,  piv + haf ) )
	{
		if( ! PribProvPivBi( z, prib, piv) )
		{
			if( Outi(   z, piv - haf,  piv + haf ) )  {res = z; return 0;}
		}
	}

	res = piv;
return 1;
}




	// Climb_Ring ..

static int Climb( float& res, float z, float prib, float piv, float haf, float ring, int modPiv=0)
{
	Abs( prib);   Abs( haf);   Abs( ring);

	//      ...
	//if( prib > (ring * 0.2f) ) return 0; //    ,   
		//      -
	ToDn(prib, ring * 0.2f);
	ToDn(haf, ring * 0.1f);

	if(modPiv) ModRing( piv, ring); //  ,     -

	Ring1( z, ring);

	// ,      (  )
	if( piv == z)  {res = piv; return 1;}  // if( FloEq( piv, z) )

	if( ! OutOnRingf( z,  piv - haf,  piv + haf, ring ) ) return res1( piv, res);

return Climb_Ring( res, z, prib, piv, haf, ring);
}


static int Climb2Pov( float& upd,  float prib, float piv, float haf, float ring, float& lastPrib);


static int Climb2( float& upd,  float prib, float piv, float haf, float ring)
{	return Climb( upd, upd, prib, piv, haf, ring);
}

static int Climb2( float& upd, float prib, float* pPivHafRing)
{
	if( ! pPivHafRing) return 0;
	return Climb( upd, upd, prib, pPivHafRing[0], pPivHafRing[1], pPivHafRing[2]);
}

static int Climb2( float& upd,  float prib, float piv, float haf)
{	return Climb( upd, upd, prib, piv, haf);
}
static int Climb2( int& upd,  int prib, int piv, int haf)
{	return Climb( upd, upd, prib, piv, haf);
}


static void RingExitUp( float& z1, float& z2, float& z3, float ring)
{
	float hafR = ring * 0.5f;
	if(z1 < hafR) z1 += ring;
	if(z2 < hafR) z2 += ring;
	if(z3 < hafR) z3 += ring;
}

static void RingExitDn( float& z1, float& z2, float& z3, float ring)
{
	float hafR = ring * 0.5f;
	if(z1 > hafR) z1 -= ring;
	if(z2 > hafR) z2 -= ring;
	if(z3 > hafR) z3 -= ring;
}










// -------  ..
//	int tt = Kmd_OuterToggle( forward_kmd_on, forwPush);
//	if( tt == 1 || tt == 2)
//	{norm root}
//	else if( tt == 3)	{ spec }
//	else	{}
//---------------------
// 0=  ., 1=  ., 2= ., 3=  KeyUp
static int Kmd_OuterToggle( int anKmd, int& outerFlag)
{
	if( anKmd > 0 )
	{
		if( outerFlag == 0) { outerFlag = 1;  return 1; }//  
		return 2; //   
	}
	else if( outerFlag == 1) { outerFlag = 0;  return 3; }//   KeyUp

return 0; //  -    .
}



	// }
	// public
private:
	// {

static int Climb_Ring( float& res, float& z, float& prib, float& piv, float& haf, float& ring);





static void PribProvPivi( int& z, int& prib, int& piv )
{
	//  - .
	if(      z > piv )  { z -= prib;  if(z < piv) z = piv; }
	else if( z < piv ) { z += prib;  if(z > piv) z = piv; }
}

static void PribProvPiv( float& z, float& prib, float& piv )
{
	if(      z > piv )  { z -= prib;  if(z < piv) z = piv; }
	else if( z < piv )  { z += prib;  if(z > piv) z = piv; }
}


static int PribProvPivBi( int& z, int& prib, int& piv )
{
	if(      z > piv )  { z -= prib;  if(z < piv) {z = piv; return 1;} }
	else if( z < piv ) { z += prib;  if(z > piv) {z = piv; return 1;} }
return 0;
}

static int PribProvPivB( float& z, float& prib, float& piv )
{
	if(      z > piv )  { z -= prib;  if(z < piv) {z = piv; return 1;} }
	else if( z < piv )  { z += prib;  if(z > piv) {z = piv; return 1;} }
return 0;
}


	// }
	// private
};






	// -+- -+- -+- -+- -+-

// Climb_Ring( float& res,
//{     ,        
// ...
		// -=-=-=-=-=-=- final ..
		//  Z  -    .

// (OR1   ..
//	if(firstR > secR) //  secNow 
//			res = secNow;
//	else	res = firstNow;
//
//	Ring1( res, ring);
//
//		// --- one more time ..
//	if( OutOnRingf(  res,   piv - haf,  piv + haf,  ring ) ) return 0;
// )OR1
//
// (OR2   ..
//	if(firstR > secR) //  secNow 
//	{
//		Ring1( secNow, ring);
//		res = secNow;
//
//		altPiv = piv;
//		RingExitDn( z, altPiv, secNow, ring); // //   Z 
//		if( Outxf( altPiv,   z, secNow) ) //  -
//		{
//			// --- one more time ..
//			if( OutOnRingf(  res,  piv - haf,  piv + haf,  ring ) ) return 0;
//		}
//	}
//	else
//	{
//			// firstNow  
//		Ring1( firstNow, ring);
//		res = firstNow;
//
//		altPiv = piv;
//		RingExitUp( z, altPiv, firstNow, ring);
//		if( Outxf( altPiv,   z, firstNow) )
//		{
//			// --- one more time ..
//			if( OutOnRingf(  res,   piv - haf,  piv + haf,  ring ) ) return 0;
//		}
//	}
// )OR2


//	res = piv;
//return 1;
//} end of //static int Climb_Ring( float& res,












//}
#endif // FintZn_INCLUDED

