// was  a_mem.cpp
//


	#include <windows.h>

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>  //     
#include <iostream>
#include <string>
#include <fstream>	 // file streams
//#include <iomanip.h> // input output
#include <vector>
#include <memory.h>

// ------------------------------
typedef std::string sStr;
typedef unsigned char BYTE;
typedef unsigned char byte;
typedef unsigned int UINT;

//#include "unpak.h"


#include "mem.h"



extern int Rand2( int mini=1, int maxi=6);





	// INC_PACKFILE1 // 
//packfile_t* gPakFile; // .






// convStr05.h




const char* gEngTextSimbChar = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

const char* gEngVarNameCharCPPAftFirst =
"0123456789_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

const char* gEngVarNameCharCPGenAftFirst =
".:0123456789_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";


int EngTextSimb(BYTE b)
{
	char ch[2];  ch[0] = b;  ch[1] = '\0';  sStr s0 = ch;

	if( s0.find_first_of( gEngTextSimbChar) == -1) return 0;
return 1;
}

int EngTextSimb(char ch1)
{
	char ch[2];  ch[0] = ch1;  ch[1] = '\0';  sStr s0 = ch;

	if( s0.find_first_of( gEngTextSimbChar) == -1) return 0;
return 1;
}

int EngTextSimb(sStr s1, UINT atPos=0)
{
	if(s1.length() > atPos)
	{
		sStr s0 = sStr(s1, atPos, 1);

		if( s0.find_first_of( gEngTextSimbChar) == -1) return 0;
	}
	else return 0;
return 1;
}




// ----------

//BYTE SToByte(const sStr& s)  { return (BYTE)( atoi(s.c_str()) ); }

//int SToInt(const sStr& s)  { return (atoi(s.c_str())); }

//float SToFlo(const sStr& s)  { return (float)(atof(s.c_str())); }


BYTE SToByte(const sStr& s)
{
BYTE b;
signed char sb;
int i;

	if( s.length()==0 ) return 0;
	i = atoi( s.c_str() );
	if(i < 0)
	{
		if(i < -128) return 0;
		else
		{
			sb = (signed char)i; memcpy(&b, &sb,1); return b;
		}
	}
	if(i > 255) i = 255;
	return (BYTE)i;
}


short SToShort(const sStr& s)
{
int i;

	if( s.length()==0 ) return 0;
	i = atoi( s.c_str() );
	if(i < -32768) return 0;
	if(i > 32767) i = 32767;
	return (short)i;
}

WORD SToUShort(const sStr& s)
{
int i;

	if( s.length()==0 ) return 0;
	i = atoi( s.c_str() );
	if(i < 0) return 0;
	if(i > 65536) i = 65536;
	return (WORD)i;
}


int SToInt(const sStr& s)  { return (int)(atoi(s.c_str())); }

UINT SToUInt(const sStr& s)  { return (UINT)(atol(s.c_str())); }


float SToFlo(const sStr& s)  { return (float)(atof(s.c_str())); }

double SToDbl(const sStr& s)  { return (double)(atof(s.c_str())); }








	// (minimChars as 10) is max
std::string IntToS(int i, int minimChars)
{
sStr s = "";

char buf[32];
	itoa(i, buf, 10); //  


	switch(minimChars)
	{
	case 2:
		//    10,     
		if(i < 10) s = "0";
	break;

	case 3:
		if(i < 10)		s =  "00";
		else if(i < 100) s = "0";
	break;

	case 4:
		if(i < 10)		s =  "000";
		else if(i < 100) s = "00";
		else if(i < 1000) s = "0";
	break;

	case 5:
		if(i < 10)		s =  "0000";
		else if(i < 100) s = "000";
		else if(i < 1000) s = "00";
		else if(i < 10000) s = "0";
	break;

	case 6:
		if(i < 10)		s =  "00000";
		else if(i < 100) s = "0000";
		else if(i < 1000) s = "000";
		else if(i < 10000) s = "00";
		else if(i < 100000) s = "0";
	break;

	case 7:
		if(i < 10)		s =  "000000";
		else if(i < 100) s = "00000";
		else if(i < 1000) s = "0000";
		else if(i < 10000) s = "000";
		else if(i < 100000) s = "00";
		else if(i < 1000000) s = "0";
	break;


	case 8:
		if(i < 10)		s =  "0000000";
		else if(i < 100) s = "000000";
		else if(i < 1000) s = "00000";
		else if(i < 10000) s = "0000";
		else if(i < 100000) s = "000";
		else if(i < 1000000) s = "00";
		else if(i < 10000000) s = "0";
	break;

	case 9:
		if(i < 10)		s =  "00000000";
		else if(i < 100) s = "0000000";
		else if(i < 1000) s = "000000";
		else if(i < 10000) s = "00000";
		else if(i < 100000) s = "0000";
		else if(i < 1000000) s = "000";
		else if(i < 10000000) s = "00";
		else if(i < 100000000) s = "0";
	break;

	case 10:
		if(i < 10)		s =  "000000000";
		else if(i < 100) s = "00000000";
		else if(i < 1000) s = "0000000";
		else if(i < 10000) s = "000000";
		else if(i < 100000) s = "00000";
		else if(i < 1000000) s = "0000";
		else if(i < 10000000) s = "000";
		else if(i < 100000000) s = "00";
		else if(i < 1000000000) s = "0";
	break;

	default: break;
	}

	s.append( buf );
	return s;
}





std::string IntToS(int i)
{
char buf[32];
	itoa(i, buf, 10); //  
	return sStr(buf);
}



sStr ByteToS(BYTE i)
{
char buf[8];
	itoa((int)i, buf, 10);
	return sStr(buf);
}




sStr TextUpperS( sStr& s) // Make an uppercase copy of s
{
short slen = s.length(); if (slen < 1) return "";
char* buf = new char[ slen ];

  s.copy(buf, slen);
  for(int i=0; i < slen; i++) buf[i] = toupper(buf[i]);

  sStr r(buf, slen);

  delete [] buf;
  return r;
}



sStr TextLowerS( sStr& s) // Make a lowercase copy of s
{
short slen = s.length(); if (slen < 1) return "";
char* buf = new char[ slen ];

  s.copy(buf, slen);
  for(int i=0; i < slen; i++) buf[i] = tolower(buf[i]);

  sStr r(buf, slen);
  delete [] buf;
  return r;
}



sStr TextTrimS(const sStr& s)
{
  if( s.length() == 0 ) return s;

  int b = s.find_first_not_of(" \t");
  int e = s.find_last_not_of(" \t");

  if(b == -1) return "";// No non-spaces // 
  return sStr(s, b, e - b + 1);//  ,   , 
}



//   .,  .,   
sStr  TextReplaceS( sStr s, sStr f, sStr new_part)
{
short* mpos;
UINT found = s.find(f); if (found == std::string::npos) return s;

short flen=f.length(), rlen=new_part.length();
short nowpos=0, predlen=0, kolvo=0;
sStr dej = s;

mpos = new short[ s.length() + 1];

  while(found != std::string::npos) // found -  "-"
  {
	mpos[nowpos] = found + predlen; predlen += rlen; nowpos++; kolvo++;
	dej.replace(found, flen, "");
    found = dej.find(f);
  }

  for (nowpos=0; nowpos < kolvo; nowpos++)
  {
	  s.replace(mpos[nowpos], flen, new_part);
  }

delete [] mpos;
return s;
}



// -----------

	// -1=   ., 0   =      
int TextPos(const char* main, sStr f, int from)
{
UINT i1 = 0;
sStr s = main;
	s = s.substr( from, s.length() ); //    eos
	i1 = s.find( f ); //.,   -1

	if (i1 != std::string::npos)
		return from + i1;
	else
		return -1;
}




// -----

//	sStr s1nm = "Torg";
//	sStr s2nm = "wEorg";// 
//	printf("\n %s %s  same=%d", s1nm.c_str(), s2nm.c_str(), TextPartSame( s1nm, 1,  s2nm, 2 ));
//
//	s2nm = "wTorg2"; // -   
//	printf("\n %s %s  same=%d", s1nm.c_str(), s2nm.c_str(), TextPartSame( s1nm, 1,  s2nm, 2 ));
//
//
//	sStr s1nm = "Torg";
//	sStr s2nm = "wEorg";//  
//	printf("\n %s %s  same=%d", s1nm.c_str(), s2nm.c_str(), TextPartSame( s1nm, 1,  s2nm, 1 ));
//
//	s2nm = "wTorg2"; // 
//	printf("\n %s %s  same=%d", s1nm.c_str(), s2nm.c_str(), TextPartSame( s1nm, 0,  s2nm, 1,  4 ));

int TextPartSame( sStr& s1, int s1beg,  sStr& s2, int s2beg,  int klv)
{
	if(klv < 1)//   
	{
		if(!s1beg && !s2beg)//    // -
		{
			if(s1 == s2) return 1; else return 0;
		}

		if(s1beg == s2beg)
		{
			if(s1.length() != s2.length()) return 0;
			if( std::string(s1, s1beg, s1.length() - s1beg) ==
				std::string(s2, s1beg, s1.length() - s1beg) ) return 1; else return 0;
		}
		else if( (s1.length()-s1beg) != (s2.length()-s2beg) ) return 0;

		//     ..
		if( std::string(s1, s1beg, s1.length()-s1beg) ==
			std::string(s2, s2beg, s1.length()-s1beg) ) return 1; else return 0;
	}





	int mlen1 = s1.length() - s1beg;
	int mlen2 = s2.length() - s2beg;

	if(mlen1 != mlen2)
	{	if( (mlen1 < klv) || (mlen2 < klv) ) return 0; //   -
	}
	//     -,      ...

	if( std::string(s1, s1beg, klv) ==
		std::string(s2, s2beg, klv) ) return 1; else return 0;



//	int s1j = s1beg;
//	int s2j = s2beg;
//
//	for( int i=0; i < klv; i++)
//	{
//		//if( ( s1j < slen1 ) &&( s2j < slen2 ) ) {}
//		if( s1j > slen1 - 1 ) break;
//		if( s1.at(s1j++) != s2.at(s2j++) ) return 0;
//	}
//return 1;

}






	//      (s1)  
	//  RemoveBloksFromString( anLine, "/*", "*/");  //  
int RemoveBloksFromString( sStr& s1, sStr beginBlok, sStr endBlok)
{
	int chang=0;
	int kpos, kblok=0;
	int begLen = beginBlok.length();
	int endLen = endBlok.length();

	for(int for1=0; for1<99999; for1++)
	{
		kpos = TextPos( s1.c_str(), beginBlok, 0); //     -
		if( kpos == -1) break; // -  

		kblok = kpos+begLen; //   ,     

		kpos = TextPos( s1.c_str(), endBlok, kblok); //    -  
		if( kpos == -1) break; // -     -  - 

		//     		//dej.replace(found, flen, "");
		s1.replace( kblok-begLen, kpos-(kblok-begLen)+endLen, "");
		chang = 1;

		//   ,      "/*x*/ 333  /*y*/ 555"
	}
return chang;
}








int RemoveBloksFrLineWfStrings( sStr& s1, sStr beginBlok, sStr endBlok)
{
	//           .
	//   -  -    -.
	//      -.

	//   , 
	// ( "D'Art"   , -   -)
	// ( "D\'Art"   )
	//     " an 'an2' "
	//     =    .

	//   -       
	//         ...
	//     -  -  
	//      ,    
	//   ,      
	// -      ... - 
	//         
	//   - "  -" ...


	int i, first;
	int lv; //   // 0= -    -
	int sec = 0;
	int wQ1, wQ2, wK; //  ,  ,  

	if( s1.length() < 2 ) return 0;
	if( beginBlok.length() < 1 ) return 0;
	if( endBlok.length() < 1) return 0;

	if( beginBlok.at(0)=='\"' ) return 0;
	if( endBlok.at(0)=='\"' ) return 0;

	if( beginBlok.at(0)=='\'' ) return 0;
	if( endBlok.at(0)=='\'' ) return 0;

	int beglen = beginBlok.length();
	int endlen = endBlok.length();

reScanStr:
	lv=0; wQ1=0; wQ2=0; wK=0;  first = -1;

	for( i=0; i < s1.length(); i++)
	{
		if( i > 0)
		{
		//	if( lv && (wQ1==lv) ) //   ,     
		//	{
		//		if( ( s1.at(i) == '\'' ) &&( s1.at(i-1) != '\\' ) ) { lv -= 1; wQ1=0; continue;}
		//	}
			if( lv && (wQ2==lv) )
			{
				if( ( s1.at(i) == '\"' ) &&( s1.at(i-1) != '\\' ) ) { lv -= 1; wQ2=0; continue;}
			}
			if( (lv==1) && wK )
			{
				if( TextPartSame( s1, i,  endBlok, 0,  endlen) )
				{
					s1.replace( first, i+endlen-first, "");   sec = 1;   goto reScanStr;
				}
			}


			if( ( s1.at(i) == '\"' ) &&( s1.at(i-1) != '\\' )   &&(!wQ2) ) {lv += 1; wQ2= lv;}
		//	else if( ( s1.at(i) == '\'' ) &&( s1.at(i-1) != '\\' )   &&(!wQ1) ) {lv += 1; wQ1= lv;}
			else if( ( ! lv) && TextPartSame( s1, i,  beginBlok, 0,  beglen) )
			{  //    
				lv= 1;  wK= lv;   first = i;   i += (beglen-1);
			}
		}
		else
		{
			if( ( s1.at(i) == '\"') &&(!wQ2) ) {lv += 1; wQ2= lv;}
		//	else if( ( s1.at(i) == '\'') &&(!wQ1) ) {lv += 1; wQ1= lv;}
			else if( ( ! lv) && TextPartSame( s1, i,  beginBlok, 0,  beglen) )
			{  //    
				lv= 1;  wK= lv;   first = i;   i += (beglen-1); // i    
			}
		}
	}// for i

return sec;
}




// -1=   ., 0   =      
int FindInLineIgnorStrings( sStr& s1, sStr findSt, int from, int nom)
{
	// nom     -    .
	//        ABC  nom as 2
	//     ABC  -   
	//   -,   ,     
	//      .


	if( s1.length() < 1 ) return -1;
	if( findSt.length() < 1 ) return -1;
	if( findSt.at(0)=='\"' ) return -1;
	if( from < 0) return -1;
	if( nom < 1) return -1;

	int i;
	int lv=0; //   // 0= -    -
	int wQ2=0; //  
	int flen = findSt.length();
	int cnt=0;

	for( i=from; i < s1.length(); i++)
	{
		if( i > from)
		{
			if( lv && (wQ2==lv) )
			{
				if( ( s1.at(i) == '\"' ) &&( s1.at(i-1) != '\\' ) ) { lv -= 1; wQ2=0; continue;}
			}

			if( ( s1.at(i) == '\"' ) &&( s1.at(i-1) != '\\' )   &&(!wQ2) ) {lv += 1; wQ2= lv;}
			else if( ( ! lv) && TextPartSame( s1, i,  findSt, 0,  flen) ) //    
			{
				cnt++;			if( nom == cnt) return i;		else i += (flen-1);
			}
		}
		else
		{
			if( ( s1.at(i) == '\"') &&(!wQ2) ) {lv += 1; wQ2= lv;}
			else if( ( ! lv) && TextPartSame( s1, i,  findSt, 0,  flen) ) //    
			{
				cnt++;			if( nom == cnt) return i;		else i += (flen-1);
			}
		}
	}// for i

return -1;
}












void StringLinkLinesRead( sStr& s1, std::ifstream& frs)
{
sStr s2="";
	//for(;;)
	for(int for1=0; for1<99999; for1++)
	{
		if( s1.length() < 1 ) return;
		if( s1.at( s1.length()-1 ) != '\\' ) return; // length()  

		s1.replace( s1.length()-1, 1, "" ); //   
		std::getline( frs, s2); //   
		s1.append( s2);
		s1 = TextTrimS( s1); //   
	}
}


	// ----
	//        
	//     -     
	//       - 
	//        
	//    .
int BigKomentSkipRead( sStr& s1, std::ifstream& frs)
{
	int slen, clos=0;
	//for(;;)
	for(int for1=0; for1<999990; for1++)
	{
		std::getline( frs, s1);  if( frs.eof()) break;
		s1 = TextTrimS( s1);   slen = s1.length();

		if( ! clos)
		{
			if(slen != 2) continue; //   
			if( ( s1.at(0) == '*' ) &&( s1.at(1) == '/' ) ) { clos = 1; } //  
		continue;
		}

		if(slen < 1) continue;
		if(slen == 2)
		{
			if( ( s1.at(0) == '/' ) &&( s1.at(1) == '/' ) ) continue; // 
			if( ( s1.at(0) == '*' ) &&( s1.at(1) == '/' ) ) continue; //  
			if( ( s1.at(0) == '/' ) &&( s1.at(1) == '*' ) ) {clos=0; continue;}
		}

		break;
	}//for
return clos;
}










int ValidNameVarCPP( sStr s1)
{
	//       .
	//      .

	s1 = TextTrimS( s1);

	char ch = s1.at(0);  if(( ! EngTextSimb( ch) ) &&( ch != '_' )) return 0;

	if( s1.find_first_not_of( gEngVarNameCharCPPAftFirst) != -1 ) return 0;
return 1;
}



int ValidNameVarCPGen( sStr s1)
{
	//       .
	//      .
	//         - 

	s1 = TextTrimS( s1);

	char ch = s1.at(0);

	if( ch == ':' )
	{	if( s1.at(1) != ':' ) return 0; else  ch = s1.at(2);
	}

	if(( ! EngTextSimb( ch) ) &&( ch != '_' )) return 0;

	if( s1.find_first_not_of( gEngVarNameCharCPGenAftFirst) != -1 ) return 0;
return 1;
}






sStr AnTextWordFrom( sStr baseLine, int from, int& breakFoundAt,
						   sStr breakChars=" \t\r\n\"\'\\{}()[]*+-/=><,.:;~&^%!|?@#$" )
{
	breakFoundAt = baseLine.find_first_of( breakChars.c_str(), from);
	if(breakFoundAt == 0) return ""; // -  ,   " "
	if(breakFoundAt == -1) return baseLine.substr( from, baseLine.length() - from );

	return baseLine.substr( from, breakFoundAt - from );
}








	// Priv1
int SMF_PreWord_AnyName_( sStr& s0, int& i, int& tmp,
						 int& NameInMas, int& NameStaPos, int& NameLen)
{
	NameLen = s0.length(); if(NameLen < 1) return 0;
	NameInMas = i;
	NameStaPos = tmp;
	return 1;
}


	//   ..
	//    ,       ...
	//   -   From  - (sPre),  return 0;
	//   ,         
	//   INT,       
	//  - ,     .
	// AnyName          , 
	//   ,  NameInMas     ( ).
	// NameStaPos  -   AnyName ...
int SMasFind_PreWord_AnyName( sStr* mas, int i, int masLen, sStr sPre, int from,
					 int& PreStaPos, int& PreLen,
					 int& NameInMas, int& NameStaPos, int& NameLen)
{
	if(from < 0) return 0;
	int kpos, tmp;

	kpos = FindInLineIgnorStrings( mas[i], sPre, from);
	if(kpos == -1) return 0;
	PreStaPos = kpos; // key-word found.
	PreLen = sPre.length();
	sStr s0 = "";

	if( mas[i].length() > kpos + PreLen ) //      
	{
		if( mas[i].at( kpos + PreLen) != ' ' ) return 0; //    -

		tmp = kpos + PreLen + 1;
		if( mas[i].length() > tmp )
		{
				kpos = mas[i].find_first_not_of( " \t", tmp); //  (-  -)
				if(kpos != std::string::npos)
				{
					s0 = AnTextWordFrom( mas[i], tmp, kpos);
					return SMF_PreWord_AnyName_(s0, i, tmp, NameInMas, NameStaPos, NameLen);
				}
		}
	}

	//   - -  -
	i++;
	if(i < masLen)
	{
		s0 = AnTextWordFrom( mas[i], 0, kpos);
		return SMF_PreWord_AnyName_(s0, i, tmp, NameInMas, NameStaPos, NameLen);
	}
return 0;
}













int findInStrEND(std::string& s1)
{
	//s1 = TextTrimS(s1);
	if(TextPos( s1.c_str(), "end", 0) == -1) return 0;
return 1;
//	if( (s1.at(0) == 'e') && (s1.at(1) == 'd') && (s1.at(2) == 'd') ) return 1;
//	return 0;
}

int findInStrBEGIN(std::string& s1, std::ifstream& frs)
{
	for(int i=0; i < 99; i++)
	{
		std::getline(frs, s1);
		if( frs.eof() ) break;//for
		s1 = TextTrimS(s1);
		if(TextPos( s1.c_str(), "begin", 0) == 0) return 1;
	}
return 0;
}

int findNonEmptyStr(std::string& s1, std::ifstream& frs)
{
	for(int i=0; i < 99; i++)
	{
		std::getline(frs, s1);
		if( frs.eof() ) break;//for
		s1 = TextTrimS(s1);
		if(s1.length() < 1)
		{
			continue;
		}
		else
		{
			if( s1.length() > 1)
			{ //   -,   
				if( s1.at(0) == '/' && s1.at(1) == '/') continue;
				if( s1.at(0) == '|' ) continue; //  -    ...
			}
			return 1;
		}
	}
return 0;
}




//   fromPos      -1
//        fromPos   s1.length()
std::string NextStringBefComa( std::string& s1, int& fromPos)
{
	std::string s2 = "";

	if(fromPos < 0) return s2;
	if(fromPos >= s1.length()) { fromPos = -1; return s2;}

	int doKonca = s1.length() - fromPos; //0..5 //Len=6 //from=2 //doKonca=4

	int posCm = TextPos(s1.c_str(), ",", fromPos);
	//if(posCm < 0) { fromPos = -1; return s2;} //      
	if(posCm < 0)
	{
		s2 = std::string( s1, fromPos, doKonca);
		fromPos = s1.length(); //       -
	}
	else
	{
		s2 = std::string( s1, fromPos, posCm - fromPos);
		fromPos = posCm + 1;
	}


	return TextTrimS( s2);
}



















sStr MixForString64( const char* fmt, ... )
{
char buf[65];
sStr  s1 = "";
va_list ap;

	if (fmt == 0) return s1;

	memset( buf, 0, 65); //    65   "   " -

	va_start(ap, fmt);
		vsprintf( buf, fmt, ap);
	va_end(ap);

	s1 = buf;
return s1;
}




sStr MixForString300( const char* fmt, ... )
{
char buf[301];
sStr  s1 = "";
va_list ap;

	if (fmt == 0) return s1;

	memset( buf, 0, 301);

	va_start(ap, fmt);
		vsprintf( buf, fmt, ap);
	va_end(ap);

	s1 = buf;
return s1;
}








// [<+>]_ _[<+>]_ _[<+>]_ _[<+>]_ _[<+>]_ _[<+>]_ _[<+>]_ _[<+>]
// (>-<)-+-(>-<)-+-(>-<)-+-(>-<)-+-(>-<)-+-(>-<)-+-(>-<)-+-(>-<)



// **************       sStr

extern int org2n_EngText();


sStr SysDateString(short mode, short ForceEng)
{
short sh=1;
sStr s1;
SYSTEMTIME stime;


	if(mode > 999)
	{
		mode -= 1000;
		GetLocalTime( &stime ); // -   .
	}
	else GetSystemTime( &stime ); // -   ...




	switch(mode)
	{
	case 1:
		if ( !ForceEng ) sh = org2n_EngText();

		if ( !sh )
		{
			switch(stime.wMonth)
			{
			case 1: s1="_-"; break;
			case 2: s1="_-"; break;
			case 3: s1="_-"; break;
			case 4: s1="_-"; break;
			case 5: s1="_-"; break;
			case 6: s1="_-"; break;
			case 7: s1="_-"; break;
			case 8: s1="_-"; break;
			case 9: s1="_-"; break;
			case 10: s1="_-"; break;
			case 11: s1="_-"; break;
			case 12: s1="_-"; break;
			}
		}
		else
		{
			switch(stime.wMonth)
			{
			case 1: s1="_Jan-"; break;
			case 2: s1="_Feb-"; break;
			case 3: s1="_Mar-"; break;
			case 4: s1="_Apr-"; break;
			case 5: s1="_May-"; break;
			case 6: s1="_Jun-"; break;
			case 7: s1="_Jul-"; break;
			case 8: s1="_Aug-"; break;
			case 9: s1="_Sep-"; break;
			case 10: s1="_Okt-"; break;
			case 11: s1="_Nov-"; break;
			case 12: s1="_Dec-"; break;
			}
		}

		s1.insert( 0, IntToS( stime.wYear ) );
		s1.append( IntToS( stime.wDay ) );
	break;


	case 2:	//  ..

		s1 = MixForString64( "%04d_%02d_%02d_%02d_%02d_%02d", //   
				stime.wYear, stime.wMonth, stime.wDay, stime.wHour, stime.wMinute, stime.wSecond );

	break;


	case 3:
		//    ..
	break;


	default: //  ..
		s1 = "_m" + IntToS( stime.wMonth ) + "_";
		s1.insert(0, IntToS( stime.wDay ));
		s1.append(IntToS( stime.wYear ));
	break;
	}


	return s1;
}








sStr SysTimeString(short mode)
{
sStr s1;
SYSTEMTIME stime;


	if(mode > 999)
	{
		mode -= 1000;
		GetLocalTime( &stime ); // -   .
	}
	else GetSystemTime( &stime );


	switch (mode)
	{
	case -1:
		s1 = IntToS( stime.wHour ) + IntToS( stime.wMinute ) +
			IntToS( stime.wSecond);
		 break;

	case 1:
		s1 = "h_" + IntToS( stime.wMinute ) + "min_";
		s1.insert(0, IntToS( stime.wHour ));
		s1.append(IntToS( stime.wSecond ) + "sec");
		 break;

	case 2: // -----    ..
		if(stime.wHour < 10)
		{
			s1 = "0";	s1.append(IntToS( stime.wHour ));
		}
		else
			s1 = IntToS( stime.wHour );

		s1.append(":");
		if(stime.wMinute < 10) s1.append("0");

		s1.append(IntToS( stime.wMinute ));
		 break;

	default:
		s1 = "_" + IntToS( stime.wMinute ) + "m_";
		s1.insert(0, IntToS( stime.wHour ));
		s1.append(IntToS( stime.wSecond ) + "s");
		 break;
	}

	return s1;
}







t_Char128 general_datetime;


char* MixDateCh(short dateMode, short timeMode, short forceEng)
{
	sStr s0 = SysDateString(dateMode, forceEng);
	general_datetime.Clear();
	if( (dateMode + timeMode) > 1999) s0.append("<Loc>");
	else if( dateMode > 999) s0.append("<DGr_"); //  -
	else if( timeMode > 999) s0.append("_TGr>"); //  -
	else s0.append("<Gr>");
	s0.append( SysTimeString(timeMode) );

	// 19_m2_2004<Gr>16_52m_56s
	s0.copy(&general_datetime.Buf[0], s0.length() ); //, ,   =0

	return &general_datetime.Buf[0];
}

char* MixDateChLoc(short forceEng)
{
	return MixDateCh( 1000, 1000, forceEng);
}


















	//             1310
	//     - "- -  1310  -"
	// frs.eatwhite();       
int streamGetToZ1310( std::ifstream& frs )
{
	//    -      , 
	// -   ...
	//          
	//     -    13    -.

	char anChar;
	while( ! frs.fail() ) //frs.get(anChar) )
	{
		frs.get(anChar);
		if( anChar == 13 )
		{
			frs.get(anChar);
			if(anChar == 10) return 1;
		}
		else if( anChar == 10 ) //        13
		{
			return 1;
		}
	}
	return 0; //    ...
}


















void ByteRead(BYTE& bb, FILE* ff) //bool   
		{ if (ff != NULL) fread( &bb, 1, 1, ff); }

void ShortRead(short& sh, FILE* ff)
		{ if (ff != NULL) fread( &sh, sizeof(short), 1, ff); }

void UShortRead(WORD& sh, FILE* ff)
		{ if (ff != NULL) fread( &sh, sizeof(WORD), 1, ff); }


void IntRead(int& ii, FILE* ff)
		{ if (ff != NULL) fread( &ii, sizeof(int), 1, ff); }

void UIntRead(UINT& ii, FILE* ff)
		{ if (ff != NULL) fread( &ii, sizeof(UINT), 1, ff); }


void FloRead(float& fi, FILE* ff)
		{ if (ff != NULL) fread( &fi, sizeof(float), 1, ff); }

void DblRead(double& di, FILE* ff)
		{ if (ff != NULL) fread( &di, sizeof(double), 1, ff); }




//----------------------------------------
int ByteWrite(BYTE bb, FILE* ff)
{	if (ff) return fwrite( &bb, 1, sizeof(BYTE), ff);
	else return 0;
}

int ShortWrite(short sh, FILE* ff)
{	if (ff) return fwrite( &sh, 1, sizeof(short), ff);
	else return 0;				// ^   "2" 
}

int UShortWrite(WORD sh, FILE* ff)
{	if (ff) return fwrite( &sh, 1, sizeof(WORD), ff);
	else return 0;
}

int IntWrite(int ii, FILE* ff)
{	if (ff) return fwrite( &ii, 1, sizeof(int), ff);
	else return 0;				// ^   "4" 
}

int UIntWrite(UINT ii, FILE* ff)
{	if (ff) return fwrite( &ii, 1, sizeof(UINT), ff);
	else return 0;
}

int FloWrite(float fi, FILE* ff)
{	if (ff) return fwrite( &fi, 1, sizeof(float), ff);
	else return 0;
}

int DblWrite(double di, FILE* ff)
{	if (ff) return fwrite( &di, 1, sizeof(double), ff);
	else return 0;
}





//     .    -  
//     .
int CharStringWrite( const char* fraza, FILE* ff )
{
int i=0, t=0;
BYTE nolik = 0;

	if (ff == NULL) return 0;
	if (!fraza) return 0; //     

			//      ( " + 1")
	i = strlen(fraza) + 1;		IntWrite( i, ff);
	t = fwrite( fraza, 1, i-1, ff);		ByteWrite(nolik, ff);

	//if (t == (i-1))
		return (i + sizeof(int));
	//else return -(t + sizeof(int)); // 
}





//int CharBlockWrite( const char* fraza, int NWB, FILE* ff )

// NWB: -1=(  )       (  )..
int CharBlockWrite( sStr fraza, int NWB, FILE* ff )
{
int i=0, t=0;
BYTE nolik = 0;

	if (!ff) return 0;

	if (NWB < 1)
	{
		if(NWB == -1)
		{
			i = fraza.length();
			IntWrite( i+1, ff); //     (klv)
			fwrite( fraza.c_str(), 1, i, ff); // 
			ByteWrite(nolik, ff);
			return i + 1 + sizeof(int);
		}
		return 0; //Need Write Bytes
	}


	if( fraza.length() > 0 )
	{
		i = fraza.length();

		if ((i+1) > NWB) // ( + __)
		{
			fraza = sStr(fraza, 0, NWB-1); //  
			i = fraza.length(); // 
		}

		IntWrite( i+1, ff); //     (klv)

		fwrite( fraza.c_str(), 1, i, ff); // 

		for (t=0; t < (NWB - i); t++) ByteWrite(nolik, ff); // .
	}
	else
	{
		IntWrite( 0, ff);
		for (t=0; t < NWB; t++) ByteWrite(nolik, ff); //.
	}

	return NWB + sizeof(int);
}


//fread( _, sizeof(_), kolvo, ff);
//fwrite( _, sizeof(_), kolvo, ff);
//..  .,  ,  ., 












//MyFileWrite

// ---------------------
//    ,   - ( win98)
//    .
//   -     .

// re: 0 - (or Add)., 1 ., 2 bak., 3 bak+editOld  (md: 0=wb  1=w+b  2=a+b)
FILE* BinFileWrite( sStr name, sStr ext, short re, short md)
{
sStr s0;
FILE* ff = NULL;

	if( name.length() < 1 ) return NULL;
	if( ext.length() > 0 ) name.append(ext);

	ff = fopen( name.c_str() , "rb"); //  - 
	if ( ff )
	{
		fclose(ff);

		if(re == 3)
		{
			s0 = name; s0.append("_bak");
			if( ! CopyFile(name.c_str(),s0.c_str(),0) ) return NULL;
			ff = fopen( name.c_str() , "r+b");
			goto norm_exit;
		}
		else if(re == 2)
		{
			// ------  ..
			s0 = name; s0.append("_bak"); ff = fopen( s0.c_str() , "rb");
			if(ff){fclose(ff); if( ! DeleteFile( s0.c_str() ) ) return NULL;}

			if( ! MoveFile(name.c_str(),s0.c_str()) ) return NULL;

		}
		else if( re  == 1)
		{
			if( ! DeleteFile( name.c_str() ) ) return NULL;
		}
		else
		{
			if(md != 2) return NULL;
		}

	}

	// -------    ..
	switch(md)
	{
	case 1: ff = fopen( name.c_str() , "w+b"); break;
	case 2: ff = fopen( name.c_str() , "a+b"); break;
	default: ff = fopen( name.c_str() , "wb"); break;
	}

norm_exit:
	if ( ! ff ) return NULL;

	return ff;
}





















// ------------------------------
				//        ByteLenta




	ByteLenta::ByteLenta()
	{
		Buf = NULL; Pos = 0; Len = 0;
	}

	ByteLenta::ByteLenta(const ByteLenta& anLenta)
	{
		MAlloc(anLenta.Len, 1);
		memcpy( &(Buf[0]), &(anLenta.Buf[0]), Len);
	}


	// ourBLenta = anBLenta;
	ByteLenta& ByteLenta::operator = (const ByteLenta& RLenta)
	{
		if(this == &RLenta)            // Check addresses, if equal
			return *this;              // return the 1st operand
		//     Tank1 = pTekTank
		//         Tank1

		Sbros(); // Release memory for 1st operand
		MAlloc(RLenta.Len, 1);
		memcpy( &(Buf[0]), &(RLenta.Buf[0]), Len);

		return *this; // Return a reference to 1st operand
	}



	void ByteLenta::HoldSqvMix(ByteLenta& LLenta, ByteLenta& RLenta) //   +
	{
		MAlloc( LLenta.Len + RLenta.Len, 1);

		memcpy( &(Buf[0]),			&(LLenta.Buf[0]), LLenta.Len);
		memcpy( &(Buf[LLenta.Len]), &(RLenta.Buf[0]), RLenta.Len);
	}


		//    ...  memcpy   ,  MovePos=1
	void ByteLenta::BlokRead( void* target, int kolvoByte,   int MovePos)
	{
		if(kolvoByte < 1) return;
		if( ! target ) return;

		memcpy( target, &(Buf[Pos]),	kolvoByte );

		if( MovePos ) Pos += kolvoByte;
	}





	// ------------------------------

	ByteLenta::~ByteLenta()
	{
		Sbros();
	}

	void ByteLenta::Sbros()
	{
		if(Buf) free(Buf); Buf = NULL; Pos = 0; Len = 0;
	}


	void ByteLenta::MAlloc(UINT NeedBytes, short NeedNew)
	{
		if(NeedNew) {Sbros();} else {if(Buf) return;}
		Buf = (BYTE*)malloc(NeedBytes);
		Pos = 0;
		Len = NeedBytes;
	}

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BYTE ByteLenta::ByteRead(short MovePos)
{
	if(!Buf) return 0;	if ( (Pos+sizeof(BYTE)) > Len ) return 0;

	BYTE i = Buf[Pos]; if(MovePos) Pos++;	return i;
}


short ByteLenta::ShortRead(short MovePos)
{
	if(!Buf) return 0;	if ( (Pos+sizeof(short)) > Len ) return 0;

	BYTE *t = Buf; t += Pos; if(MovePos) Pos += sizeof(short);
	return *(short*)t;
}


WORD ByteLenta::UShortRead( short MovePos)
{
	if(!Buf) return 0;	if ( (Pos+sizeof(WORD)) > Len ) return 0;

	BYTE *t = Buf; t += Pos; if(MovePos) Pos += sizeof(WORD);
	return *(WORD*)t;
}


int ByteLenta::IntRead( short MovePos)
{
	if(!Buf) return 0;	if ( (Pos+sizeof(int)) > Len ) return 0;

	BYTE *t = Buf; t += Pos; if(MovePos) Pos += sizeof(int);
	return *(int*)t;
}


UINT ByteLenta::UIntRead( short MovePos)
{
	if(!Buf) return 0;	if ( (Pos+sizeof(UINT)) > Len ) return 0;

	BYTE *t = Buf; t += Pos; if(MovePos) Pos += sizeof(UINT);
	return *(UINT*)t;
}


float ByteLenta::FloRead( short MovePos)
{
	if(!Buf) return 0.0f;	if ( (Pos+sizeof(float)) > Len ) return 0.0f;

	BYTE *t = Buf; t += Pos; if(MovePos) Pos += sizeof(float);
	return *(float*)t;
}


double ByteLenta::DblRead( short MovePos)
{
	if(!Buf) return 0.0;	if ( (Pos+sizeof(double)) > Len ) return 0.0;

	BYTE *t = Buf; t += Pos; if(MovePos) Pos += sizeof(double);
	return *(double*)t;
}

// ---------


	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BYTE ByteLenta::AnByteRead(int offset)
{
	if(!Buf) return 0;	if ( (offset+sizeof(BYTE)) > Len ) return 0;

	return Buf[offset];
}


short ByteLenta::AnShortRead(int offset)
{
	if(!Buf) return 0;
	if ( ((offset*sizeof(short))+sizeof(short)) > Len ) return 0;

	BYTE *t = Buf; t += (offset*sizeof(short));
	return *(short*)t;
}


WORD ByteLenta::AnUShortRead(int offset)
{
	if(!Buf) return 0;
	if ( ((offset*sizeof(WORD))+sizeof(WORD)) > Len ) return 0;

	BYTE *t = Buf; t += (offset*sizeof(WORD));
	return *(WORD*)t;
}


int ByteLenta::AnIntRead(int offset)
{
	if(!Buf) return 0;
	if ( ((offset*sizeof(int))+sizeof(int)) > Len ) return 0;

	BYTE *t = Buf; t += (offset*sizeof(int));
	return *(int*)t;
}


UINT ByteLenta::AnUIntRead(int offset)
{
	if(!Buf) return 0;
	if ( ((offset*sizeof(UINT))+sizeof(UINT)) > Len ) return 0;

	BYTE *t = Buf; t += (offset*sizeof(UINT));
	return *(UINT*)t;
}


float ByteLenta::AnFloRead(int offset)
{
	if(!Buf) return 0.0f;
	if ( ((offset*sizeof(float))+sizeof(float)) > Len ) return 0.0f;

	BYTE *t = Buf; t += (offset*sizeof(float));
	return *(float*)t;
}


double ByteLenta::AnDblRead(int offset)
{
	if(!Buf) return 0.0;
	if ( ((offset*sizeof(double))+sizeof(double)) > Len ) return 0.0;

	BYTE *t = Buf; t += (offset*sizeof(double));
	return *(double*)t;
}





 //     ., LenCopy=0    ., 1=   
void ByteLenta::CopyTo( ByteLenta* bl2,		int LenCopy, int SrcFromZero)
{
	//  - -  CopyFrom.

	//bl2->Len
	//bl2->Pos
	//bl2->Buf

	int SrcPos, SrcLen;

	if(!bl2) return; //  
			//     ...  -.

		//   
	if(SrcFromZero) SrcPos = 0; else SrcPos = Pos;

	if(LenCopy < 1) SrcLen = Len - SrcPos; // 
	else if(LenCopy > (Len - Pos)) SrcLen = Len - SrcPos;

	if( SrcLen > (bl2->Len - bl2->Pos) )
		SrcLen = (bl2->Len - bl2->Pos);

	memcpy( &(bl2->Buf[bl2->Pos]), &Buf[SrcPos], SrcLen);

}
//------------------------------------







	//   ( )
void ByteLenta::AddOtherBL( ByteLenta* anLenta )
{
	int NowLen = Len;
	int NowPos = Pos;
	if(!anLenta) return;
	if(!anLenta->Buf) return;
	if(anLenta->Len < 1) return;

	Pos=0; //   " "
	Add( NowLen + anLenta->Len);
	Pos=NowPos; //
	memcpy( &(Buf[NowLen]), &(anLenta->Buf[0]), anLenta->Len);

}





void ByteLenta::DeleteTailFrom(int FromPos)
{
	if(FromPos<1)
	{
		Sbros(); //  
		return;
	}

	if(FromPos >= Len) return; //   -  -.

	Buf = (BYTE*)realloc(Buf, FromPos);
	Len = FromPos;
	if(Pos >= Len) Pos = Len-1;
}



	//         . ( 3   2)
int ByteLenta::SetLastPos()
{
	if(Len < 1) return -1; // -  .
	Pos = Len-1;
	return Pos;
}






int ByteLenta::CountEOL(int withNonEndLine)
{
	if(Len<1) return 0;
	if(Len<2){if(withNonEndLine) return 1; else return 0;}

	int cnt=0;
	if(withNonEndLine) cnt=1;

	for(int i=0; i < (Len-1); i++)
	{
		if( Buf[i] == 13 )
		{
			if( Buf[i+1] == 10 )	{ cnt++; i++; }
		}
	}
	return cnt;
}


int ByteLenta::SkipToEOL()
{
	//for(;;)
	for(int for1=0; for1<99999000; for1++)
	{
		if( Pos == Len )
		{
			Pos = 0;	break; // for
		}

		if( Buf[Pos] == 13 )
		{
			if( Buf[Pos+1] == 10 ) //    :))
			{
				Pos += 2;
				return 1; //    
			}
		}

		Pos += 1;
	}//for

	return 0;
}




int ByteLenta::SetPosToFirstNormCharInLine( BYTE firstNorm)
{
	//for(;;)
	for(int for1=0; for1<99999000; for1++)
	{
		if( Pos == Len )
		{
			Pos = 0;	break; // for
		}

		if( Buf[Pos] == 13 )
		{
			if( Buf[Pos+1] == 10 ) //    :))
			{
				Pos += 2;
				return 0; //    ,   
			}
		}
		else if( Buf[Pos] > (firstNorm-1) ) // 48-57 
		{
			return 1;
		}

		// 65-90  


		Pos += 1;
	}

	return 0;
}













void ByteLenta::SdvigLenPlus( int ofsSdvig, int klvBytes )
{
	BYTE* BufTemp = NULL;

	if( klvBytes < 1 ) return;
	if( ofsSdvig >= Len) return;
	if( ofsSdvig < 0) return;

	//         FreeTailBytes ..
	// "     "
	//      50-800     
	//  -- ,     


	int tempPos = Pos;
	int NowLen = Len;

	Pos=0; //   " "
	Add( NowLen + klvBytes );
	NowLen = NowLen - ofsSdvig; //  

	Pos = tempPos; //     
						//       Pos = ofsSdvig

	BufTemp = (BYTE*)malloc(NowLen);
	if(!BufTemp) return;

	memcpy( BufTemp, &(Buf[ofsSdvig]), NowLen); //   
	memcpy( &(Buf[ofsSdvig+klvBytes]), BufTemp, NowLen); //  

	free(BufTemp);

}




void ByteLenta::SdvigLenMinus( int ofsSdvig, int klvBytes )
{
	BYTE* BufTemp = NULL;

	if( klvBytes < 1 ) return;
	if( ofsSdvig >= Len) return;
	if( ofsSdvig < 0) return;

	if( klvBytes > ofsSdvig ) klvBytes = ofsSdvig;

	int NowLen = Len - ofsSdvig; //  

	BufTemp = (BYTE*)malloc(NowLen);
	if(!BufTemp) return;

	memcpy( BufTemp, &(Buf[ofsSdvig]), NowLen); //   
	memcpy( &(Buf[ofsSdvig-klvBytes]), BufTemp, NowLen); //  
	free(BufTemp);

	DeleteTailFrom( Len - klvBytes ); //  
			//   ,   -  
		//         ...

}



void ByteLenta::CutLenMinus( int ofscut, int klvBytes )
{
	BYTE* BufTemp = NULL;

	if( klvBytes < 1 ) return;
	if( ofscut >= Len) return;
	if( ofscut < 0) return;

	if( (ofscut+klvBytes) >= Len )
	{
		DeleteTailFrom( ofscut ); //  
		return;
	}
	// ------
	//        ...

	int ofsCopy = ofscut + klvBytes;
	int NowLen = Len - ofsCopy; //  

	BufTemp = (BYTE*)malloc(NowLen);
	if(!BufTemp) return;

	memcpy( BufTemp, &(Buf[ofsCopy]), NowLen); //   
	memcpy( &(Buf[ofscut]), BufTemp, NowLen);
	free(BufTemp);

	DeleteTailFrom( ofscut + NowLen ); //  

}









	// Name.,  1  .,  -1  " "., 1 "   ".
int ByteLenta::SaveToFile( sStr FileName, int NeedReWrite, int LenCopy, int SrcFromZero)
{
	int SrcPos, SrcLen, tt;
	FILE* f;

	if( !Buf ) return 0;

	f = BinFileWrite(FileName, "", NeedReWrite);	if ( !f ) return 0;


	if(SrcFromZero) SrcPos = 0; else SrcPos = Pos;

	if(LenCopy < 1) SrcLen = Len - SrcPos;
	else if(LenCopy > (Len - Pos)) SrcLen = Len - SrcPos;


	tt = fwrite( &Buf[SrcPos], 1, SrcLen, f);
	fclose(f);

return tt;
}
//------------------------------------







void ByteLenta::ByteWrite( BYTE an, short MayAdd)
{
	int i = sizeof(an);
	if(MayAdd) { Add(i); } // ,    ..
	else {if(!Buf) return;	if (  (Pos + i) > Len  ) return;}

	memcpy( &Buf[Pos], &an, i); Pos += i;
}

void ByteLenta::ShortWrite( short an, short MayAdd)
{
	int i = sizeof(an);
	if(MayAdd) { Add(i); } else {if(!Buf) return;	if (  (Pos + i) > Len  ) return;}
	memcpy( &Buf[Pos], &an, i); Pos += i;
}

void ByteLenta::UShortWrite( WORD an, short MayAdd)
{
	int i = sizeof(an);
	if(MayAdd) { Add(i); } else {if(!Buf) return;	if (  (Pos + i) > Len  ) return;}
	memcpy( &Buf[Pos], &an, i); Pos += i;
}

void ByteLenta::IntWrite( int an, short MayAdd)
{
	int i = sizeof(an);
	if(MayAdd) { Add(i); } else {if(!Buf) return;	if (  (Pos + i) > Len  ) return;}
	memcpy( &Buf[Pos], &an, i); Pos += i;
}

void ByteLenta::UIntWrite( UINT an, short MayAdd)
{
	int i = sizeof(an);
	if(MayAdd) { Add(i); } else {if(!Buf) return;	if (  (Pos + i) > Len  ) return;}
	memcpy( &Buf[Pos], &an, i); Pos += i;
}

void ByteLenta::FloWrite( float an, short MayAdd)
{
	int i = sizeof(an);
	if(MayAdd) { Add(i); } else {if(!Buf) return;	if (  (Pos + i) > Len  ) return;}
	memcpy( &Buf[Pos], &an, i); Pos += i;
}

void ByteLenta::DblWrite( double an, short MayAdd)
{
	int i = sizeof(an);
	if(MayAdd) { Add(i); } else {if(!Buf) return;	if (  (Pos + i) > Len  ) return;}
	memcpy( &Buf[Pos], &an, i); Pos += i;
}






void ByteLenta::FillRand(int caseRND, int beginPos, int LenPart)
{

	if((beginPos > -1) && (beginPos < Len) )
		Pos = beginPos;
	else
		beginPos = Pos;


	if( (LenPart > Len) || (LenPart < 1) ) LenPart = Len - beginPos;

	if(LenPart > (Len - Pos) ) LenPart = (Len - Pos); // ??


	//beginPos+LenPart

	switch(caseRND)
	{
	case 3: //   (0..1)
		//for(;;)
		for(int for1=0; for1<99999000; for1++)
		{
			if( Pos > (beginPos+LenPart - sizeof(float) ) ) break;
			FloWrite( float( rand() % 100 + 1)  *  (1.0f / float(100)) );
		}
	break;

	default: //  .
		//for(;;)
		//{
		//	if(Pos > (beginPos+LenPart - 1)) break;
		//	// ...
		//}
	break;
	}

}









void ByteLenta::Add(int size_an)
{
		if(Buf)
		{
			if (  (Pos + size_an) > Len  )
			{
				Len = (Pos + size_an);
				Buf = (BYTE*)realloc(Buf, Len);
				//if(Buf) Len = (Pos + size_an);

				//if(!Buf) Sbros();
			}
		}
		else //    -    .
		{
			MAlloc( Pos + size_an, 1);
		}
}







 //- -      ... (  )
//friend ByteLenta operator + (const ByteLenta& LLenta, const ByteLenta& RLenta);
ByteLenta operator + (ByteLenta& LLenta, ByteLenta& RLenta)
{
	ByteLenta BL;

	BL.MAlloc( LLenta.Len + RLenta.Len, 1);

	memcpy( &(BL.Buf[0]),			&(LLenta.Buf[0]), LLenta.Len);
	memcpy( &(BL.Buf[LLenta.Len]), &(RLenta.Buf[0]), RLenta.Len);

   return BL;
}














//    ...
//      -   ...
//       -      ...

	// TGA, BMP, PNG, DDS, JPG, TEX
sStr NameTypeImageUni( sStr  File_NameDotU )
{
	FILE* ff = NULL;
	sStr s1 = File_NameDotU;

	UINT found = s1.find(".u", s1.length() - 2 ); //     // "name.u"  4 
						//         

	if (found == std::string::npos) return s1;

	// File_NameDotU          :))
	File_NameDotU.replace( found, 2, "" ); // pos, klv, new_string

	//  -      ..

	s1 = File_NameDotU;	s1.append(".tga");		ff = fopen( s1.c_str() , "rb");		if(ff)	goto ex1;
	s1 = File_NameDotU;	s1.append(".bmp");		ff = fopen( s1.c_str() , "rb");		if(ff)	goto ex1;
	s1 = File_NameDotU;	s1.append(".png");		ff = fopen( s1.c_str() , "rb");		if(ff)	goto ex1;
	s1 = File_NameDotU;	s1.append(".dds");		ff = fopen( s1.c_str() , "rb");		if(ff)	goto ex1;
	s1 = File_NameDotU;	s1.append(".jpg");		ff = fopen( s1.c_str() , "rb");		if(ff)	goto ex1;
	s1 = File_NameDotU;	s1.append(".tex");		ff = fopen( s1.c_str() , "rb");		if(ff)	goto ex1;

ex1:
	if(ff) fclose(ff);

	return s1;
}












	void str3int::LoadText(const char* str12)
	{
		int s12L = strlen(str12);
		//if( s12L > 11) s12L = 11;
		if( s12L > 12) s12L = 12;

		int1 = 0; int2 = 0; int3 = 0;
		memcpy( &int1,    str12,     s12L);
	}

	void str3int::LoadFromStreamLine( std::ifstream &frs )
	{
		sStr s;
		std::getline( frs, s );
		s = TextTrimS( s );
		//s.replace( 12, s.length() - 12, ""); //  ? // -   12 .
		LoadText( s.c_str() );
	}

	char* str3int::pCharStr()
	{
		return (char*) &int1;
	}




void str3intWrite( str3int& Name12, FILE* ff)
{
	if(! ff) return;
	IntWrite( Name12.int1, ff);
	IntWrite( Name12.int2, ff);
	IntWrite( Name12.int3, ff);
}

void str3intRead( str3int& Name12, FILE* ff)
{
	if(! ff) return;
	IntRead( Name12.int1, ff);
	IntRead( Name12.int2, ff);
	IntRead( Name12.int3, ff);
}






void BinBlok::start( FILE* ff)
{
	BinBlo_reElemKlv = 0;
	BinBlo_rePosition = ftell(ff); IntWrite( BinBlo_reElemKlv, ff);
}

void BinBlok::fwd()
{
	BinBlo_reElemKlv += 1;
}

void BinBlok::end( FILE* ff)
{
	int normPos = ftell(ff);
	fseek(ff, BinBlo_rePosition, SEEK_SET);   IntWrite( BinBlo_reElemKlv, ff);
	fseek(ff, normPos, SEEK_SET); // #define SEEK_SET    0
}










int IntWriteMem( int* intZero, int* intZeroLast, FILE* ff,  int LimKlv)
{
	int wrtKlv=0;
	int* psv = intZero;
	for(int i=0; i < LimKlv; i++)
	{
		IntWrite( *psv, ff);   wrtKlv += 1;
		if(psv == intZeroLast) return wrtKlv;   psv++;
	}
return wrtKlv;
}

int IntReadToMem( int* intZero, int* intZeroLast, FILE* ff,  int LimKlv)
{
	int anInt, readKlv=0;
	int* psv = intZero;
	for(int i=0; i < LimKlv; i++)
	{
		IntRead( anInt, ff);  *psv = anInt;   readKlv += 1;
		if(psv == intZeroLast) return readKlv;  psv++;
	}
return readKlv;
}






int FloWriteMem( float* floZero, float* floZeroLast, FILE* ff,  int LimKlv)
{
	int wrtKlv=0;
	float* psv = floZero;
	for(int i=0; i < LimKlv; i++)
	{
		FloWrite( *psv, ff);   wrtKlv += 1;
		if(psv == floZeroLast) return wrtKlv;   psv++;
	}
return wrtKlv;
}

int FloReadToMem( float* floZero, float* floZeroLast, FILE* ff,  int LimKlv)
{
	float anFlo;
	int readKlv=0;
	float* psv = floZero;
	for(int i=0; i < LimKlv; i++)
	{
		FloRead( anFlo, ff);  *psv = anFlo;   readKlv += 1;
		if(psv == floZeroLast) return readKlv;  psv++;
	}
return readKlv;
}








int WriteToMem( int* intZero, int* intZeroLast, int zna, int LimKlv)
{
	int wrtKlv=0;
	int* psv = intZero;
	for(int i=0; i < LimKlv; i++)
	{
		*psv = zna;   wrtKlv += 1;
		if(psv == intZeroLast) return wrtKlv;   psv++;
	}
return wrtKlv;
}














// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% GetByteLenta


int GetByteLenta( ByteLenta& bbb, sStr name, sStr ext,
				 sStr arh, UINT sverka )
{
int i=0, t=0;
UINT sver2=0;

	if (bbb.Buf) return 0;
	else if (bbb.Pos != 0) return 0;

	if( name.length() < 1 ) return 0; //    
	if( ext.length() > 0 ) name.append(ext);

	if( arh.length() > 4 ) t = 1; // x.arh = 5 = .  

		//--------------------------------------
	if( t )
	{
//#ifdef INC_PACKFILE1
//		packfile_t ArhFile;
//		if ( PackFileOpen( &ArhFile, arh.c_str() ) )
//		{
//			i = PackFileGet2BYTE( &ArhFile, name.c_str(), &bbb.Buf);
//			bbb.Len = i; bbb.Pos = 0; //  - bbb.MAlooc()
//
//			PackFileClose( &ArhFile);
//			if (i < ( sizeof(int)+sizeof(UINT) + 1) ) return 0;
//			if (!bbb.Buf) return 0;
//		}
//		else
//#endif
			return 0;
	}
	else
	{

		FILE* f = NULL;			f = fopen( name.c_str(), "rb");

		if (f)
		{
			fseek(f, 0, SEEK_END); i = ftell(f); fseek(f, 0, SEEK_SET);
			bbb.MAlloc(i);

			if (!bbb.Buf) {fclose(f); return 0;}
			fread(bbb.Buf, i, 1, f);
			fclose(f);
		}
		else return 0;
	}

	if (sverka) //  ,     
	{	if (sver2 != sverka)
			return 0;
	}

	//     -   8   .

	return 1;
}

// GetByteLenta %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



















	t_FileDirStek::t_FileDirStek(WORD dir_LAST)
	{
		dir = NULL;
		if(dir_LAST < 3) return;
		dir_Last = dir_LAST;

		dir = new t_Char256 [dir_Last+1];

		Reset();
	}

	t_FileDirStek::~t_FileDirStek()
	{
		if(dir) delete [] dir;
		dir = NULL;
	}

	void t_FileDirStek::Reset()
	{
		if(!dir) return;
		for(int t=0; t <= dir_Last; t++) dir[t].Clear();
		now = 0;
	}

	void t_FileDirStek::_SaveStartPoint()
	{
		if(!dir) return;
		Reset();
		GetCurrentDirectory( 255, dir[now].Buf );
	}

	void t_FileDirStek::CallStartPoint()
	{
		if(!dir) return;
		SetCurrentDirectory( dir[0].Buf );
	}

		//  -       ...
		//    AnStartPoint  - -   -
	int t_FileDirStek::PushDir()
	{
		if(!dir) return 0;
		if(now >= dir_Last) return 0;
		now += 1;
		if( GetCurrentDirectory( 255, dir[now].Buf ) < 1 ) return 0;
		return now; //     
	}

		//     PushDir
	int t_FileDirStek::PopDir()
	{
		if(!dir) return 0;
		if(now < 1) return 0; // Push -
		if( ! SetCurrentDirectory( dir[now].Buf ) ) return 0;
		now -= 1;
		return now + 1; //     
	}


t_FileDirStek  FileDir1(8);











	// ------------------


//const sStr ctZaglavName = "zaglav.bin";



void Run_BakSysZaglav( sStr s1 )
{
		sStr s2 = "";
		FILE* ff = NULL;

		s2 = s1;	s2.append("/");		s2.append(ctZaglavName);
		ff = fopen( s2.c_str(), "rb" );

		if( ! ff ) return; //   -   .

		fclose(ff);

		// ---  -
		s2 = s1 + "_BAK_";
		//s2.append( DateString() );
		s2.append("_");		s2.append( IntToS( GetTickCount() ) );

		MoveFile( s1.c_str(), s2.c_str() ); // rename dir s1 to s2
}





int errPopD() //   -,  -  
{
	FileDir1.PopDir();
	return 0;
}



int SysZaglavForSave( sStr s1 )
{
	FileDir1.PushDir(); //   

	Run_BakSysZaglav( s1 );		CreateDirectory( s1.c_str(), NULL);
	if( ! SetCurrentDirectory( s1.c_str() ) ) goto err0;
	return 1;
err0:
		FileDir1.PopDir();
	return 0;
}


int SysZaglavForLoad( sStr s1 )
{
	FileDir1.PushDir(); //   

	if( ! SetCurrentDirectory( s1.c_str() ) ) goto err0;
	return 1;
err0:
		FileDir1.PopDir();
	return 0;
}







