//


#include <windows.h>

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>	 // file streams
#include <string>

#include <gl/gl.h>
#include <gl/glu.h>


	#define GL_BGR_EXT     0x80E0
	#define GL_BGRA_EXT    0x80E1



typedef std::string sStr;
typedef unsigned char BYTE;
typedef unsigned char byte;
typedef unsigned int UINT;

#include "img_up.h"
#include "mem.h"
#include "pix.h"





	//       --
sStr  globStr_TexName = "";




#define closeRetZero() {if(frs.is_open()) frs.close(); return 0;}




t_pix_Sbor  pix1;


void t_pix_Sbor::off()
{
	glDisable(GL_TEXTURE_2D);
}

void t_pix_Sbor::use(int nomTex)
{
	// if(nomTex == 0){glDisable(GL_TEXTURE_2D); return;}
	if(nomTex > t_pix_Sbor_Last || nomTex < 0) return;
	mas[nomTex].Bind();
}



int t_pix_Sbor::ReLoad(int nTex, sStr name1, int mips)
{
	if(nTex > t_pix_Sbor_Last || nTex < 0) return 0;

	if( ! mas[nTex].LoadImgTGA( name1) ) return 0;

	mas[nTex].GenTexture( mips, 1 );  if( ! mas[nTex].ID ) return 0;
		//SpeMemCount += mas[adr2].GetMemByteSize();

	return 1;
}


int t_pix_Sbor::ReMemLoad(int nTex, BYTE* bytes, int w, int h, int skb, int mips)
{
	if(nTex > t_pix_Sbor_Last || nTex < 0) return 0;
	if( ! bytes) return 0;

	mas[nTex].SbrosPix();

		if(skb == 1) mas[nTex].Bit =8; else if(skb == 2) mas[nTex].Bit =16;
	else if(skb == 3) mas[nTex].Bit =24; else if(skb == 4) mas[nTex].Bit =32;
	else return 0;

	mas[nTex].W = w;
	mas[nTex].H = h;
	mas[nTex].byteData = bytes;

	mas[nTex].GenTexture( mips, 0 );  if( ! mas[nTex].ID ) return 0;
		//SpeMemCount += mas[adr2].GetMemByteSize();

	//     
	mas[nTex].byteData = 0;	 //   // bytes   .

return 1;
}





int t_pix_Sbor::LoadPackTGA(std::string sborName)
{
using namespace std;

	int SpeMemCount=0;

	sStr s1 = "";//, s2 = "";
	std::ifstream frs;

	int i, adr2, klv, mips;


	frs.open( sborName.c_str() );
	if( ! frs.is_open() ) return 0;


	getline(frs, s1); //  
	frs >> klv;		//  (     )
		streamGetToZ1310( frs );// 
	if( klv > t_pix_Sbor_Last+1) klv = t_pix_Sbor_Last+1;


	for(i=0; i < klv; i++) // -------------------------
	{
		getline(frs, s1); // 
		frs >> adr2; //       ..
			streamGetToZ1310( frs );
		if( adr2 < 0) adr2 = 0;
		if( adr2 > t_pix_Sbor_Last ) adr2 = t_pix_Sbor_Last;

		//..     
		if( mas[adr2].ID ) closeRetZero();

		getline(frs, s1); // 
		//getline(frs, s2); //  ("x.arh" minim arh-name)
			if ( frs.fail() ) closeRetZero();


		//-----------   (  ) ..
		//    ,  -, 
		//   ,      ...
		// -     -    .

		globStr_TexName = TextTrimS(s1);

		//if( ! mas[adr2].LoadImg( NameTypeImageUni(globStr_TexName), TextTrimS(s2) ) )
		if( ! mas[adr2].LoadImgTGA( globStr_TexName ) ) closeRetZero();


		 //-----------   ..
		frs >> mips; streamGetToZ1310( frs );
		mas[adr2].GenTexture( mips, 1 );	if( ! mas[adr2].ID ) closeRetZero();


		SpeMemCount += mas[adr2].GetMemByteSize();

	}//for

frs.close();

	//LogInfo( "\n%s..\n gr_Pix[%d][] (%d ) ...\n", MixDateCh(), adr1, SpeMemCount);
	//o2::TexMemForGeneral = (SpeMemCount / 1000000); //  -
now = adr2 + 1;
return 1;
}




















void Pix_::SbrosPix()
{
		//if (byteData){delete [] byteData; byteData = 0;}
		if (byteData)	{free(byteData); byteData = 0; Bit =0;}
}
void Pix_::SbrosTex()
{
		if (ID){glDeleteTextures(1, &ID); ID = 0;}
}


void Pix_::Bind()
{//void Bind(int wrap_repeat=1)
		if( ID )
		{
			glEnable(GL_TEXTURE_2D); //    
			glBindTexture(GL_TEXTURE_2D, ID);

		//	if( wrap_repeat )
		//			OGL::TexRepeat();
		//	else	OGL::TexClamp();

		}
}





void Pix_::GetPixPixel( int ofsToRitX, int ofsToDnY,
			BYTE& k1, BYTE& k2, BYTE& k3, BYTE& k4)
{
		if( ! byteData) return;
		if(ofsToRitX < 0 || ofsToDnY < 0) return;
		if(ofsToRitX >= W) return;
		if(ofsToDnY >= H) return;

		ofsToDnY = (H-1) - ofsToDnY;
		int ofsP;
		if(Bit==24)			ofsP = ((W*ofsToDnY)+ofsToRitX) * 3;
		else if(Bit==32)	ofsP = ((W*ofsToDnY)+ofsToRitX) * 4;

		k1 = byteData[ ofsP ];
		k2 = byteData[ofsP+1];
		k3 = byteData[ofsP+2];
		if(Bit==32) k4 = byteData[ofsP+3]; else k4 = 0;//255;
}




void Pix_::InitEmpty(int w, int h, int bit)
{
	sbros();//SbrosPix();

	  if(bit == 32)
	  {	  byteData = (BYTE*)malloc(w*h*4);	Bit = 32;
	  }
	  else
	  {	  byteData = (BYTE*)malloc(w*h*3); Bit = 24;
	  }

	  W = w; H = h;
}





int Pix_::MemFromMips(int memForNorm)
{
		if( ! Mips ) return 0;
		if( memForNorm < 4 ) return 0;
		if( W < 2 ) return 0;
		if( H < 2 ) return 0;

		int tw = W / 2;
		int th = H / 2;
		int tM = memForNorm / 4;
		int sj = tM;

		for(int for1=0; for1<999; for1++)
		{
			if(tw < 2) break;
			if(th < 2) break;

			sj = sj / 4;
			tM += sj;

			tw = tw / 2;
			th = th / 2;
		}
		return tM;
}



int Pix_::UpdateMipmaps()
{
	if( ! Mips ) return 1;

// -  - -  -    .
// OpenGL 1.4
// #define GL_GENERATE_MIPMAP                0x8191
// #define GL_GENERATE_MIPMAP_HINT           0x8192

		//glHint(GL_FOG_HINT, GL_FASTEST);
		//glHint(GL_GENERATE_MIPMAP_HINT, ... );

		//     ,      gluBuild2DMipmaps
		// if(Bit == 24)
		//gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, W, H, GL_RGB, GL_UNSIGNED_BYTE, byteData);
		// if(Bit == 32)
		// .....

	return 0;
}


/*
    // ----- hardware generation
  if ( ogl_extensions->OpenGL14 || ogl_extensions->GL_SGIS_generate_mipmap)
  {
    glTexParameteri( GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE);  //  -
    glHint(GL_GENERATE_MIPMAP_HINT, GL_NICEST); //  - 
    glTexImage2D( GL_TEXTURE_2D, 0, (GLuint)internal, width, height, 0, external, ext_type, (GLvoid *)data );
    result = glGetError( );  if (result != GL_NO_ERROR) { return ERROR; }
  }


// ------
 glBindTexture( GL_TEXTURE_2D, (GLuint)0 ); //    .

*/





void Pix_::SetFilter()
{
	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );
	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
}


int Pix_::NormMipMapRGB()
{
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, W, H, GL_RGB, GL_UNSIGNED_BYTE, byteData);
		//       GLU ,  return 1;
		return 1;
}

int Pix_::NormMipMapRGBA()
{
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, W, H, GL_RGBA, GL_UNSIGNED_BYTE, byteData);
		//       GLU ,  return 1;
		return 1;
}






BYTE* Pix_::getImageForMipMap_TGA( int mipNom )
{
	if( mipNom < 1 ) return NULL;
	if( globStr_TexName.length() < 5 ) return NULL;

	sStr s1 = "";
		s1 = globStr_TexName; //    name.BMP
		s1.replace( s1.length() - 4,  4,  "" ); //   ,  ,  
		s1.append( IntToS(mipNom) ); // IntToS(mipNom + 1)
		s1.append(".tga");



	FILE* f = fopen( s1.c_str(), "rb");	if(!f) return 0; //   
	int size;
		fseek(f, 0, SEEK_END);  size = ftell(f);  fseek(f, 0, SEEK_SET); //  
		if(size < 1) {fclose(f); return 0;}

		int tW, tH, tBit;
		unsigned char*  bImgData = 0;
		unsigned char*  bData = 0;
		bData = (unsigned char*)malloc(size);  if(!bData) {fclose(f); return 0;}
		//{
			fread( bData, size, 1, f);
			fclose(f); //  -.

			bImgData = TargaDecodeTo( bData,  tW, tH, tBit);
			free(bData);//   .
		//}
	return bImgData;
}






void Pix_::finMipMap( BYTE* imgData, int& dopW, int& dopH, int startMipLevel )
{
		if( ! imgData ) return;		if(startMipLevel < 1) return;
		int ii = startMipLevel;
		for(int for1=0; for1<999; for1++)//for(;;)
		{
			dopW /= 2;		dopH /= 2;
			glTexImage2D(GL_TEXTURE_2D, ii, GL_RGB, dopW, dopH,
									0, GL_RGB, GL_UNSIGNED_BYTE, imgData);

			if( (dopW==1) && (dopH==1) ) return;
			ii += 1;
		}
}

void Pix_::finMipMap32( BYTE* imgData, int& dopW, int& dopH, int startMipLevel )
{
		if( ! imgData ) return;		if(startMipLevel < 1) return;
		int ii = startMipLevel;
		for(int for1=0; for1<999; for1++)//for(;;)
		{
			dopW /= 2;		dopH /= 2;
			glTexImage2D(GL_TEXTURE_2D, ii, GL_RGBA, dopW, dopH,
									0, GL_RGBA, GL_UNSIGNED_BYTE, imgData);

			if( (dopW==1) && (dopH==1) ) return;
			ii += 1;
		}
}









int Pix_::SpeMipMapRGB( int klv )
{
		BYTE* dopBytes= NULL;
		int dopW= W;
		int dopH= H;
		int nxt= 1;
		int nxtLast= 1;


		switch(klv)
		{
		case 7: //      .  6 .
					if( (W < 128) || (H < 128) ) return 0;
		case 6:	if( (W < 64) || (H < 64) ) return 0;
		case 5:	if( (W < 32) || (H < 32) ) return 0;
		case 4:	if( (W < 16) || (H < 16) ) return 0;
			// {


			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, W, H, GL_RGB, GL_UNSIGNED_BYTE, byteData);

			//dopW = W;		dopH = H;  
			nxtLast = klv-1;
			for(nxt=1; nxt < nxtLast+1; nxt++)
			{
				dopBytes = getImageForMipMap_TGA( nxt );
				if(dopBytes)
				{
					if(nxt == nxtLast) //   -     
					{
						finMipMap( dopBytes, dopW, dopH, nxt );
					}
					else
					{
						dopW /= 2;		dopH /= 2;
						glTexImage2D(GL_TEXTURE_2D, nxt, GL_RGB, dopW, dopH,
																	0, GL_RGB, GL_UNSIGNED_BYTE, dopBytes);
					}
					free(dopBytes);  dopBytes = NULL;
				}
			}

			break; // }




		default:
			return NormMipMapRGB();
		}

		return 1;
}






int Pix_::SpeMipMapRGBA( int klv )
{

		BYTE* dopBytes= NULL;
		int dopW= W;
		int dopH= H;
		int nxt= 1;
		int nxtLast= 1;


		switch(klv)
		{
		case 7: //      .  6 .
					if( (W < 128) || (H < 128) ) return 0;
		case 6:	if( (W < 64) || (H < 64) ) return 0;
		case 5:	if( (W < 32) || (H < 32) ) return 0;
		case 4:	if( (W < 16) || (H < 16) ) return 0;
			// {


			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, W, H, GL_RGBA, GL_UNSIGNED_BYTE, byteData);


			nxtLast = klv-1;
			for(nxt=1; nxt < nxtLast+1; nxt++)
			{
				dopBytes = getImageForMipMap_TGA( nxt );
				if(dopBytes)
				{
					if(nxt == nxtLast) //   -     
					{
						finMipMap32( dopBytes, dopW, dopH, nxt );
					}
					else
					{
						dopW /= 2;		dopH /= 2;
						glTexImage2D(GL_TEXTURE_2D, nxt, GL_RGBA, dopW, dopH,
																	0, GL_RGBA, GL_UNSIGNED_BYTE, dopBytes);
					}
					free(dopBytes);  dopBytes = NULL;
				}
			}

			break; // }




		default:
			return NormMipMapRGBA();
		}

		return 1;
}








// name1    -  .
void SavePixData1( sStr name1, BYTE* bytes, int w, int h, int bytesInPixel, int linesPere)
{
	switch(bytesInPixel)
	{
	case 1: case 2: case 3: case 4:  break; // .
	default: return;
	}

	if( linesPere)  VMirror( bytes, w, h, bytesInPixel);

	int kilo = w * h * bytesInPixel;

	FILE* f =0;  f = fopen( name1.c_str(), "wb");
	if(f)
	{
		fwrite( &w, sizeof(int), 1, f);
		fwrite( &h, sizeof(int), 1, f);
		fwrite( &bytesInPixel, sizeof(int), 1, f);
		fwrite( bytes, kilo, 1, f);
		fclose(f);
	}
}








		int SavePixDataOnLoadTex = 0;//1;


int Pix_::LoadImgTGA(sStr name)
{
	int size;
	FILE* f = fopen( name.c_str(), "rb");	if(!f) return 0; //   

	SbrosPix();


int razv =1;

	if(name.length() > 4)
	{
		if( name.at(name.length() - 4) == '.' ) razv=0;
	}

	if(razv)//alter
	{
		int skb;
		fread( &W, sizeof(int), 1, f);
		fread( &H, sizeof(int), 1, f);
		fread( &skb, sizeof(int), 1, f); size = W * H * skb;
		byteData = (unsigned char*)malloc(size); if(!byteData) {fclose(f); return 0;}
		fread( byteData, size, 1, f);
		fclose(f);
				if(skb == 1) Bit =8; else if(skb == 2) Bit =16;
			else if(skb == 3) Bit =24; else if(skb == 4) Bit =32;
		return 1;
	}
	//--------



		fseek(f, 0, SEEK_END);  size = ftell(f);  fseek(f, 0, SEEK_SET); //  
		if(size < 1) {fclose(f); return 0;}

		unsigned char*  bData = 0;
		bData = (unsigned char*)malloc(size);  if(!bData) {fclose(f); return 0;}
		//{
			fread( bData, size, 1, f);
			fclose(f); //  -.

			//    
			byteData = TargaDecodeTo( bData,  W, H, Bit);


	// --- extra..
	if( byteData && SavePixDataOnLoadTex) //SavePixDataOnLoadTex    
	{
		SavePixData1( name.replace(name.length() - 4, 4, ""),  byteData, W, H, Bit / 8);
			// - ( )
	}
	// fin extra



			free(bData);//   .
		//}
		if( ! byteData ) return 0;
	return 1;
}



/*
int Pix_::LoadImg(sStr name, sStr arh, int fint)
{
int t=0;
  char ext[] = "---";

  if( name.length() < 5) return 0;
  name = TextLowerS( name );
  name.copy( ext, 3, name.length()-3 ); //  
		// if (!_stricmp(ext, "tt")) t=1;   - ...

  SbrosPix();

	bitmap image;
	//image.data = NULL; //-       .

  if ( ReadImage2( &image, name, arh, fint) )
  {
	  if(image.data)
	  {
		  Bit = image.bpp;	  W = image.width;	  H = image.height;

		  byteData = image.data;

	  }
	  else goto error_exit;


		if (!_stricmp(ext, "tga")) t=1;
		if (!_stricmp(ext, "tt")) t=1;
		if (!_stricmp(ext, "jpg")) t=1;
		if (!_stricmp(ext, "ris")) t=1;
		if(t) byteData = VertikMirror(byteData, W, H, Bit);

			//GenTexture(needMips, deleteImage);
		// -      -  ...
	  return 1;
  }

error_exit:

	LogInfo( "\n%s..\n %s: %s\n  arh(%s)",
		MixDateCh(), MsgBase(26), name.c_str(), arh.c_str() );
			// -  

  return 0;
}
*/










	// Mode=2  RGBA
int Pix_::DrawImg(int LDnUgX, int LDnUgY, int Mode)
{

	if(!byteData) return -1;

//	if(o2::State2D != 1) return 0;

	glRasterPos2i(LDnUgX, LDnUgY);


	switch(Mode)
	{
	case 1: //  BGR or BGRA
		if(Bit == 24)
			glDrawPixels(W, H, GL_BGR_EXT, GL_UNSIGNED_BYTE, byteData);
		else if(Bit == 32)
			glDrawPixels(W, H, GL_BGRA_EXT, GL_UNSIGNED_BYTE, byteData);
		else
			return 0;
	break;

	default:
		if(Bit == 24)
			glDrawPixels(W, H, GL_RGB, GL_UNSIGNED_BYTE, byteData);
		else if(Bit == 32)
			glDrawPixels(W, H, GL_RGBA, GL_UNSIGNED_BYTE, byteData);
		else
			return 0;
	break;
	}

	return 1;
}












int Pix_::GenTexture(int NeedMips, int DelData)
{
	if(!byteData) return 0;
	//if((Bit != 24) && (Bit != 32)) return 0;
	if((Bit != 8) && (Bit != 16) && (Bit != 24) && (Bit != 32)) return 0;

	SbrosTex();

	glGenTextures(1, &ID);

	glBindTexture(GL_TEXTURE_2D, ID);
	//glPixelStorei(GL_UNPACK_ALIGNMENT, 1); // 1 2 4 8
		//-   -    (4)



//	OGL::TexRepeat();
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);



	//glTexParameterf ( GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 2.0f );

		//OGL::L_Modulate();
			//   -  - -   - ...
			//---------


GLint iForm = GL_RGB;
GLenum pixForm = GL_RGB;

if(Bit == 32){iForm = GL_RGBA; pixForm = GL_RGBA;}
else if(Bit == 16){iForm = GL_LUMINANCE_ALPHA; pixForm = GL_LUMINANCE_ALPHA; NeedMips =0;}
else if(Bit == 8){iForm = GL_LUMINANCE; pixForm = GL_LUMINANCE; NeedMips =0;}



	Mips = 0;


	if(NeedMips > 0)
	{
		SetFilter();

		if(Bit == 32)
		{
			if(NeedMips == 1)
					Mips = NormMipMapRGBA();
			else	Mips = SpeMipMapRGBA(NeedMips);
		}
		else
		{
			if(NeedMips == 1)
					Mips = NormMipMapRGB(); //  -   .
			else	Mips = SpeMipMapRGB(NeedMips);
		}

	}

	if(Mips == 0)
	{
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);//GL_NEAREST
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);//GL_NEAREST
	}

		// ----     ..
	glTexImage2D(GL_TEXTURE_2D, 0, iForm, W, H,
                      0, pixForm, GL_UNSIGNED_BYTE, byteData);




   if(DelData) SbrosPix();


   return 1;

}



















int OGL_SaveViewportToBMP( sStr FileName )
{
int vport[4];

Pix_ screen1;

	if( FileName.length() < 1 ) return 0;

	//---
	glGetIntegerv(GL_VIEWPORT, vport);

	screen1.InitEmpty( vport[2], vport[3], 24);
    if( ! screen1.byteData ) return 0;

	glFinish();

	//---
glPushClientAttrib(GL_CLIENT_ALL_ATTRIB_BITS);

  glPixelStorei(GL_PACK_ALIGNMENT, 3);
  glPixelStorei(GL_PACK_ROW_LENGTH, 0);
  glPixelStorei(GL_PACK_SKIP_ROWS, 0);
  glPixelStorei(GL_PACK_SKIP_PIXELS, 0);

  glReadPixels(0, 0, vport[2], vport[3], GL_BGR_EXT,  GL_UNSIGNED_BYTE, screen1.byteData);

glPopClientAttrib();

	//---
	if( writeBmp24( FileName.c_str(), screen1.W, screen1.H,
					screen1.byteData, 0, 0) ) return 1;

return 0;
}



