//    


/*
    .

0 1 2
3 4 5

0,0   W,0   W*2,0
0,W   W,W   W*2,W

"W"  - .
       .
//  openGL     

----------

    // aStarLibrary.h
       - ,  .

     ..
 http://algolist.manual.ru/games/smartmove.php
 http://www.policyalmanac.org/games/aStarTutorial_rus.htm
Google.. Pathfinder by Patrick Lester

*/






// ---
//    ..

class t_masKle
{
public:

	Kle  m[ KleMasKlv];

	BYTE  mapDark[ KleMasKlv];

	UINT mapDarkTex;



void init()
{
	int k = 0, i, j;
	float x = 0.f, z = 0.f; //  

	for( i =0; i < KleZKlv; i++) //  
	{
		for( j =0; j < KleXKlv; j++) // //  
		{
			m[k].tx = x;  m[k].tz = z;

			m[k].visual = klVisNorm2;

			if( Rand2(0,3) ) m[k].visual = klVisNorm;

			k++;

			x += KleW; // 
		}
		x = 0.f; //    
		z += KleW; //    
	}

	RestoreBort(); //    
	ReVisualBort();//  




	mapDarkSbros( 0); //      
	// ----
	mapDarkTex = 0;
	glGenTextures(1, &mapDarkTex);
	glBindTexture(GL_TEXTURE_2D, mapDarkTex);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);//GL_CLAMP_TO_EDGE
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);// -,  .
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); // .

		//   //-   
	glTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE_ALPHA, KleXKlv, KleZKlv,
                      0, GL_LUMINANCE, GL_UNSIGNED_BYTE, mapDark);

    // ---
	mapDarkSbros();
		//       ...
		//   OnStartLap
}




void exit()
{
	if(mapDarkTex) {glDeleteTextures(1, &mapDarkTex); mapDarkTex = 0;}

}

void mapDarkTexBind()
{
	if( ! mapDarkTex) return;
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, mapDarkTex);
}



void mapDarkSbros( BYTE x =60) //255
{
	//for( int k =0; k < KleMasKlv; k++) mapDark[ k] = x;
	memset( mapDark, x, KleMasKlv); // memset( mapDark, x, KleMasKlv * sizeof(BYTE));
}


void mapDarkAddSvet( float rpx, float rpz, float Rad)
{
	//  -    .

	float x = rpx - Rad;
	float z = rpz - Rad;
	float x2 = rpx + Rad;
	float z2 = rpz + Rad;

	while( x < KleW) { x += KleW; }
	while( z < KleW) { z += KleW; }
	while( x2 > KlePoleW) { x2 -= KleW; }
	while( z2 > KlePoleH) { z2 -= KleW; }

	int gKle = (x2 - x) / KleW;  gKle +=1; //   ,    
	int vKle = (z2 - z) / KleW;  vKle +=1;

	int t;
	int k = LentaPoleFrom0_NomYchUnder2( x, z,  0, 0, KleW, KleW, KleXKlv, KleZKlv);
	//if( KleOut(k) ) return;

	//setSpec
	for( int j =0; j < vKle; j++) //
	{
		for( int i =0; i < gKle; i++)
		{
			t = k + i;  if( KleOut(t) ) continue;
			// ifSpec
			mapDark[t] = 0; //  //  
		}
		k += KleXKlv;
	}

}






// [] = ;

//  " -     "

int KleOut(int K)
{
	if((K < 0) || (K >=  KleMasKlv)) return 1; return 0;
}

//       
// ..  ,   .
int NomFrom2( int xTileFr1, int zTileFr1)
{
	if( xTileFr1 < 1 || xTileFr1 > KleXKlv) return -1;
	if( zTileFr1 < 1 || zTileFr1 > KleZKlv) return -1;

	int K = (zTileFr1 - 1) * KleXKlv + (xTileFr1 - 1);
	if(KleOut(K)) return -1;
	return K;
}

//       ...
void NomTo2( int K, int& xtFr0, int& ztFr0)
{
	xtFr0 = K % KleXKlv;
	ztFr0 = K / KleXKlv;//   
}







// -  ""    
int isLBort(int k)
{
	if(KleOut(k)) return 0;

	if( ! (k % KleXKlv) ) return 1;

return 0;
}

// -  ""    
int isRBort(int k)
{
	if(KleOut(k)) return 0;

	if( (k % KleXKlv) == (KleXKlv - 1) ) return 1; //  

	return 0;
}

// -  ""   ( )
int isTopBort(int k)
{
	if(KleOut(k)) return 0;

	if( k < KleXKlv ) return 1;

	return 0;
}

// -  ""   ( )
int isBBort(int k)
{
	if(KleOut(k)) return 0;

	if( k >= (KleMasKlv - KleXKlv) ) return 1;

	return 0;
}

// -  "" -  
int isAnyBort(int k)
{
	if(       isLBort(k) ) return 1;
	else if( isRBort(k)   ) return 1;
	else if( isTopBort(k) ) return 1;
	else if( isBBort(k)   ) return 1;
return 0;
}




//  
// setHod setStroim setBonus
void RestoreBort( int setH =0, int setS =0, int setB =0)
{
	for( int k =0; k < KleMasKlv; k++)
	{
		if( isLBort(k) || isRBort(k) || isTopBort(k) || isBBort(k) )
		{
			m[k].hodim = setH;  m[k].stroim = setS;  m[k].bonus = setB;
		}
	}
}

//   
void ReVisualBort( int setVal =0)
{
	for( int k =0; k < KleMasKlv; k++)
	{
		if(       isLBort(k) ) m[k].visual = setVal;
		else if( isRBort(k)   ) m[k].visual = setVal;
		else if( isTopBort(k) ) m[k].visual = setVal;
		else if( isBBort(k)   ) m[k].visual = setVal;
	}
}






// -       "  ".
int inBelt1( int kC, int K, int orInCentr =0)
{
	if(KleOut(kC)) return 0;
	if(KleOut(K)) return 0;

	if(orInCentr){if(kC == K) return 1;}
	else if( kC == K) return 0;

	if( kC - 1 == K) return 1; // 
	if( kC + 1 == K) return 1; //
	if( kC - KleXKlv == K) return 1;//
	if( kC + KleXKlv == K) return 1;//

	if( kC - KleXKlv -1 == K) return 1;// 
	if( kC - KleXKlv +1 == K) return 1;// 
	if( kC + KleXKlv -1 == K) return 1;// 
	if( kC + KleXKlv +1 == K) return 1;//
return 0;
}

int inBelt1( float cRealX, float cRealZ, int K, int orInCentr =0)
{
	return inBelt1( Kle_FromXZ( cRealX, cRealZ), K, orInCentr);
}


int inRadius( int kC, float radi, float pntX, float pntZ)
{
	if(KleOut(kC)) return 0;
	vec2 cp = vec2( m[kC].tx + KleW/2.f,  m[kC].tz + KleW/2.f);
	vec2 dp = vec2(pntX, pntZ);
	cp = dp - cp;
	if( length(cp) > radi) return 0;
	return 1;
}




void XZ_FromKle(float& gX, float& gZ, int k, int needMidle = 0)
{
	if( KleOut(k) ) return;

	//    - ,    ..
	BFTileXYf( gX, gZ, k,   0, 0, KleW, KleW, KleXKlv, KleZKlv, 0);

	if(needMidle)
	{gX += KleW / 2.f;  gZ += KleW / 2.f;}
}

vec2 XZ_FromKle(int k, int needMidle = 0)
{
	vec2 an = vec2(0,0);  XZ_FromKle( an.x, an.y, k, needMidle);
	return an;
}




// -1     
int Kle_FromXZ( float rX, float rZ)
{
	int k = LentaPoleFrom0_NomYchUnder2( rX, rZ,  0, 0, KleW, KleW, KleXKlv, KleZKlv);
	if( KleOut(k) ) return -1;
	if( isAnyBort(k) ) return -1;
	return k;
}



// 1    // 2    //   
int isControlPoint(int k)
{
	if( KleOut(k) ) return 0;

	if( m[k].fgr )
	{
		if( m[k].fgr->status == fgrPultFlag)
			return 2; //  ,     -.
		else return 0; //- 
		// fgrPultFlag      .
		//        .
	}

	if( m[k].stroim == klStroPost) return 1;
	if( m[k].stroim == klStroCtrl) return 1;
	if( m[k].stroim == klStroPost2) return 1;
return 0;
}


// 1    // 2    //   
int isControlMine(int k)
{
	if( KleOut(k) ) return 0;

	if( m[k].fgr )
	{
		if( m[k].fgr->status == fgrPultFlag)
		{
			if(m[k].stroim == klStroMGem1
			|| m[k].stroim == klStroMGem2
			|| m[k].stroim == klStroMGem3
			|| m[k].stroim == klStroMGem4)
				return 2; //  -,     -.
			else return 0;
		}
		else return 0; //- 
	}

	if( m[k].stroim == klStroMGem1) return 1;
	if( m[k].stroim == klStroMGem2) return 1;
	if( m[k].stroim == klStroMGem3) return 1;
	if( m[k].stroim == klStroMGem4) return 1;
return 0;
}


//    
void SetK( int k, char setH, char setS, char Bon, char Vis)
{
	if(KleOut(k)) return;
	if(isAnyBort(k)) return;
	m[k].hodim =  setH;
	m[k].stroim = setS;
	m[k].bonus =  Bon;
	m[k].visual = Vis;
}


int RectOver( int k, int gx, int gz, int gw, int gh)
{
	if(KleOut(k)) return 0;
	return RectPere( m[k].tx, m[k].tz, KleW, KleW,  gx, gz, gw, gh);
}








//   
//   inLowAir  ,       -.
void AStarLaySet1( int k,
 int inLowAir, int inLitCar, int inNonSwim, int inSwimTank, int inHardTank)
{
	if(KleOut(k)) return;
	int ntx, ntz;
	NomTo2( k, ntx, ntz);

	if(inLowAir)  walkab1( ntx, ntz, 1);//unwalkable = 1;
	if(inLitCar)  walkab2( ntx, ntz, 1);//PafLay_LitCar
	if(inNonSwim) walkab3( ntx, ntz, 1);//PafLay_LandCar
	if(inSwimTank) walkab4( ntx, ntz, 1);//PafLay_WaterTank
	if(inHardTank) walkab5( ntx, ntz, 1);//PafLay_HardTank
/*
..
inLowAir -        "".
inLitCar -          ,   .
inNonSwim -   ,    -    .
inSwimTank -   ,     " ".
inHardTank -     " "   .
*/
}





//     -    
void ClearFillAStarLayers()
{
	//    -     .

	walkabil_Init(); // AStarLayers.Clear(); //  .

	for(int k =0; k < KleMasKlv; k++) //   .
	{ //  .

		switch(m[k].hodim)
		{
		//case klHodLand: break; //  
		//case klHodSnow: break;  //     -
		//case klHodSwamp: break; // --/--  -
		case klHodWater:
		//       
			AStarLaySet1( k, 0, 0, 1, 0, 1);
		break;

		case klHodHole:
		case klHodWall:
			AStarLaySet1( k, 0, 1, 1, 1, 1);
		break;

		case klHodNone:
		case klHodWall2:
			AStarLaySet1( k, 1, 1, 1, 1, 1); //   .
		break;

		default: break;
		}
	}

}









void bonCurUnderUp( int k)
{
	if( KleOut(k) ) return;

	//bonCurUnder = m[k].bonus;
	bonCurUnder = 0;
	switch( m[k].bonus)
	{
	case klBonDefGood: bonCurUnder = 1; break;
	case klBonDefBad: bonCurUnder = 2; break;
	case klBonAngel:
		//   ,  klBonDefBad
		bonCurUnder = 2;//    
	break;
	case klBonNekro:
		//   ,  klBonDefBad
		bonCurUnder = 1;//    
	break;
	default: break;
	}

}



//     //- ,   .
//    ,    .
void UpCursorUnderKle()
{
	float ex,ey,  ex2,ey2;

	//GameRectR_ProjToScreen( 0.f, 0.f,  ex, ey);
	GameRectR_ProjToScreen( m[0].tx, m[0].tz,  ex, ey);

	GameRectR_ProjToScreen( m[0].tx + KleW, m[0].tz + KleW,  ex2, ey2);

	GameRect_ScrPoleX = ex;
	GameRect_ScrPoleY = ey;
	GameRect_ScrKleW = ex2 - ex;
	GameRect_ScrKleH = ey2 - ey;
	GameRect_eScale = zn::Perc( GameRect_ScrKleW, KleW, 1.f); // 


	if( inRect( curx, cury, GameRectX, GameRectY, GameRectW, GameRectH) )
	{
		GameRect_ProjToReal( curx, cury, GameRect_CurUnderRX, GameRect_CurUnderRZ);

	GameRect_CurUnder = LentaPoleFrom0_NomYchUnder2(
		GameRect_CurUnderRX, GameRect_CurUnderRZ,  0, 0, KleW, KleW, KleXKlv, KleZKlv);
	}
	else
	{
		GameRect_CurUnder = -1; //      
	}

	bonCurUnderUp( GameRect_CurUnder);
}



















void GenerClearLand()
{
	for( int k =0; k < KleMasKlv; k++)
	{
		SetK( k, klHodLand, klStroAny, klBonNone, klVisNorm);
		// 
			//    
				//   
					// 
	}

	RestoreBort();
	ReVisualBort();
}







int privMetkaXZ( float x, float z)
{
	int k = LentaPoleFrom0_NomYchUnder2( x, z,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	SetK( k, klHodLand, klStroAny, 0, 0);
}

int New1()
{
	GenerClearLand();

	//    ..
	privMetkaXZ( KlePoleW * 0.25f, KlePoleH * 0.25f);
	privMetkaXZ( KlePoleW * 0.5f,  KlePoleH * 0.25f);
	privMetkaXZ( KlePoleW * 0.75f, KlePoleH * 0.25f);

	privMetkaXZ( KlePoleW * 0.25f, KlePoleH * 0.5f);
	privMetkaXZ( KlePoleW * 0.5f,  KlePoleH * 0.5f);
	privMetkaXZ( KlePoleW * 0.75f, KlePoleH * 0.5f);

	privMetkaXZ( KlePoleW * 0.25f, KlePoleH * 0.75f);
	privMetkaXZ( KlePoleW * 0.5f,  KlePoleH * 0.75f);
	privMetkaXZ( KlePoleW * 0.75f, KlePoleH * 0.75f);
}


void Save1( sStr fname)
{
	if( fname.length() < 1) return;
	//      
	FILE* f = 0;  f = fopen( fname.c_str(), "wb"); //write bin
	if( ! f) return;

	int tKlv = KleXKlv * KleZKlv;
	IntWrite( KleXKlv, f);
	IntWrite( KleZKlv, f);

	for( int k =0; k < tKlv; k++)
	{
		fwrite( &(m[k].hodim), 4, 1, f); // ByteWrite( m[k].hodim, f);
	}
	fclose(f);

}

int Load1( sStr fname)
{
	if( fname.length() < 1) return 0;
	//       
	FILE* f = 0;  f = fopen( fname.c_str(), "rb"); //read bin
	if( ! f) return 0;

	int tkx, tkz;
	IntRead( tkx, f);
	IntRead( tkz, f);
	if( tkx != KleXKlv || tkz != KleZKlv){ fclose(f); return 0;}

	for( int k =0; k < KleMasKlv; k++)
	{
		fread( &(m[k].hodim), 4, 1, f);
	}
	fclose(f);
	return 1;
}








void privMutMapRGB( int& k, BYTE& br, BYTE& bg, BYTE& bb)
{ //    127
	switch(m[k].hodim)
	{
	case klHodNone: br = 120; bg = 120; bb = 120; break;
	case klHodHole: br = 20;  bg = 30; bb = 10; break;
	case klHodLand: br = 50;  bg = 70; bb = 40; break;
	case klHodWater: br = 20; bg = 30; bb = 90; break;
	case klHodWall:  br = 95; bg = 50; bb = 30; break;
	}
}


void privMutCase( int& k)
{
	vec2 v = XZ_FromKle( k, 1);

	switch(m[k].stroim)
	{
	case klStroEBunk:
		StaMutBuker( PlayerBanerID, KleW / 2.f + v.x, KleW / 2.f + v.y);
		SetK( k, klHodHole, klStroNone, klBonNone, klVisNorm);
	break;
	case klStroEBunk2:
		StaMutBuker( PlayerBanerID +1, KleW / 2.f + v.x, KleW / 2.f + v.y);
		SetK( k, klHodHole, klStroNone, klBonNone, klVisNorm);
		// "Hole"     ,  .
	break;
	case klStroEKExpa:
		StaMutKExpa( v.x, v.y);
		SetK( k, klHodLand, klStroNone, klBonNone, klVisNorm);
		// "HodLand"      -    .
	break;
	case klStroEXSki:
		StaMutXSki( v.x, v.y);
		SetK( k, klHodLand, klStroNone, klBonNone, klVisNorm);
	break;

	case klStroEBoxExpa:
		StaMutBoxExpa( v.x, v.y);
		SetK( k, klHodLand, klStroAny, klBonNone, klVisNorm);
	break;
	case klStroEBoxGem:
		StaMutBoxGem( v.x, v.y);
		SetK( k, klHodLand, klStroAny, klBonNone, klVisNorm);
	break;
	case klStroEBoxU1:
		StaMutBoxU1( 1, v.x, v.y);
		SetK( k, klHodLand, klStroNone, klBonNone, klVisNorm2);
			// klStroNone   "   ".
	break;
	case klStroEBoxU2:
		StaMutBoxU1( 2, v.x, v.y);
		SetK( k, klHodLand, klStroNone, klBonNone, klVisNorm2);
	break;
	}
}



void StartMutagen1()
{
	PlayerBanerID = BanerNeutral +1; //     -.

	//      ...
	Fgrs_clearAll();

	int k;
	// ,     -  ( )
	//  - ,     ...
	for( k =0; k < KleMasKlv; k++)
	{
		if( ! KleOut(k) ) privMutCase( k);
	}



		// -----    -..
	int bytesKlv = KleXKlv * KleZKlv * 3;

	BYTE* bD = (BYTE*) malloc( bytesKlv);

	int j =0;
	for( k =0; k < KleMasKlv; k++)
	{
		privMutMapRGB( k,  bD[j], bD[j +1], bD[j +2]);
		j += 3;
	}

	VMirror( bD, KleXKlv, KleZKlv, 3);
	pix1.ReMemLoad( texMMap, bD, KleXKlv, KleZKlv, 3, 0);

	// ---    - ..
	//sStr s1 = "uni_files/res/rts/mmap";
	//SavePixData1(  s1, bD,  KleXKlv, KleZKlv, 3, 1);
	//pix1.ReLoad( texMMap, s1, 0);
	//-------


	free(bD);

}















int mapDark_DarkKle( int k)
{
//    ,       .

	if( EditModeOn ) return 0; //    
	if( KleOut(k) ) return 0; //   
	if( mapDark[ k] == 0) return 0; //   ,    
	return 1;
}






void DrawLandTile( int k)
{	// DrawLand ->> DrawLandTile

	//if( KleOut(k) ) return;

	float ex,ey,  ex2,ey2;

	//    -   
	//   

	GameRectR_ProjToScreen( m[k].tx, m[k].tz,  ex, ey);

	GameRectR_ProjToScreen( m[k].tx + KleW, m[k].tz + KleW,  ex2, ey2);




	//   ,      ..

	//DWORD tmpTex = texLandNone;
	int tmpTex = texLandNone;
	switch( m[k].visual)
	{
	case klVisHole: tmpTex = texLandHole;
	break;
	case klVisNorm: tmpTex = texLandNorm;
	break;
	case klVisNorm2: tmpTex = texLandNorm2;
	break;
	case klVisWater: tmpTex = texLandWater;
	break;
	case klVisRock: tmpTex = texLandRock;
	break;
	case klVisRock2: tmpTex = texLandRock2;
	break;

	case klVisCtrl: tmpTex = texLandCtrl; //   -   
	if( k == GameRect_CurUnder){
	Render.Add3ring( tex0_Ring, 0x88AAAAAA, XZ_FromKle(k, 1), KleW * 5.f);
	Render.Add3ring( tex0_Ring, 0x99AAAAAA, XZ_FromKle(k, 1), KleW * 4.f);
		}
	break;

	case klVisPost: tmpTex = texLandPost;
	if( k == GameRect_CurUnder){
	Render.Add3ring( tex0_Ring, 0x88AADDFF, XZ_FromKle(k, 1), KleW * 4.f);
	Render.Add3ring( tex0_Ring, 0x99AADDFF, XZ_FromKle(k, 1), KleW * 3.f);
		}
	break;

	case klVisPost2: tmpTex = texLandPost2;
	if( k == GameRect_CurUnder){
	Render.Add3ring( tex0_Ring, 0x88FFFF00, XZ_FromKle(k, 1), KleW * 3.f);
	Render.Add3ring( tex0_Ring, 0x99FFFF00, XZ_FromKle(k, 1), KleW * 2.f);
		}
	break;



	case klVisBuf: tmpTex = texLandHole;
	Render.Add3ring( tex0_Ring, 0x88FFFFFF, XZ_FromKle(k, 1), KleW);
	break;

	case klVisEBunk: tmpTex = texLandRock;
	Render.Add3ring( tex0_Ring, 0xDDFF0000, XZ_FromKle(k, 1), KleW * 7);
	Render.Add3ring( tex0_Ring, 0x88FFFFFF, XZ_FromKle(k,  1), KleW * 0.5f);
	Render.Add3ring( tex0_Ring, 0x88FFFFFF, XZ_FromKle(k +1, 1), KleW * 0.5f);
	Render.Add3ring( tex0_Ring, 0x88FFFFFF, XZ_FromKle(k +KleXKlv, 1), KleW * 0.5f);
	Render.Add3ring( tex0_Ring, 0x88FFFFFF, XZ_FromKle(k +KleXKlv +1, 1), KleW * 0.5f);
	break;
	case klVisEBunk2: tmpTex = texLandRock;
	Render.Add3ring( tex0_Ring, 0xDDFF00FF, XZ_FromKle(k, 1), KleW * 7);
	Render.Add3ring( tex0_Ring, 0x88FFAAAA, XZ_FromKle(k, 1), KleW * 0.5f);
	Render.Add3ring( tex0_Ring, 0x88FFAAAA, XZ_FromKle(k +1, 1), KleW * 0.5f);
	Render.Add3ring( tex0_Ring, 0x88FFAAAA, XZ_FromKle(k +KleXKlv, 1), KleW * 0.5f);
	Render.Add3ring( tex0_Ring, 0x88FFAAAA, XZ_FromKle(k +KleXKlv +1, 1), KleW * 0.5f);
	break;


	case klVisEKExpa: tmpTex = 61;
	Render.Add3ring( tex0_Ring, 0xFFAA99AA, XZ_FromKle(k, 1), KleW * 1.2f);
	break;
	case klVisEXSki: tmpTex = 62;
	break;
	case klVisEBoxExpa: tmpTex = 63;
	break;

	case klVisEBoxGem: tmpTex = 64;
	Render.Add3ring( tex0_Ring, 0xFF7799FF, XZ_FromKle(k, 1), KleW * 0.8f);
	break;

	case klVisEBoxU1: tmpTex = texLandNorm2;
	Render.Add3ring( tex0_Ring, 0xFFAA99FF, XZ_FromKle(k, 1), KleW * 2.5f);
	break;
	case klVisEBoxU2: tmpTex = texLandNorm2;
	Render.Add3ring( tex0_Ring, 0xFF77FFFF, XZ_FromKle(k, 1), KleW * 2.5f);
	Render.Add3ring( tex0_Ring, 0xFF7799FF, XZ_FromKle(k, 1), KleW * 3.f);
	break;

	default: break;//klVisNone
	}


	NomBlend(0);

	if( mapDark_DarkKle(k) ) ColorMatF( 1.f,   0.8f, 0.8f, 0.8f);
	else
	ColorMatF();

	pix1.use( tmpTex);
	DrawQuad2D_2( ex,ey,  ex2,ey2);





	//          
	if( EditModeOn && k == GameRect_CurUnder)
		Render.Add3( tex0_Rama, 0x99224422, ex+3, ey+3, ex2-3, ey2-3, 1);

	if( EditModeOn && inBelt1( GameRect_CurUnder, k) )
		Render.Add3( tex0_Rama, 0x77FFFFFF, ex+1, ey+1, ex2-1, ey2-1, 1);



	//if( editorDrawLandGrid ) // - 
	if( EditModeOn)
		Render.Add1( tex0_Rama, 0x77112233, ex, ey, ex2, ey2, 1);


}







void DrawLand()
{
	test_TilesNarisov = 0;

	for(int k =0; k < KleMasKlv; k++)
	{
		if( GameRectReal_Fru( m[k].tx, m[k].tz, KleW, KleW) )
		{
			DrawLandTile( k);

			test_TilesNarisov += 1;
		}
	}


	//     - (   )..
	// ---
	//         ,
	//      -,    ,   .

	static int iva = 500;

	if( EditModeOn ) return;

	if( zn::ToZeroi(iva) )
	{
		iva = 500;
		//   -,  mapDark   .
		glBindTexture(GL_TEXTURE_2D, mapDarkTex);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE_ALPHA, KleXKlv, KleZKlv,
				0, GL_ALPHA, GL_UNSIGNED_BYTE, mapDark);
	}


// ---- ..
//	float ex,ey,  ex2,ey2;
//	GameRectR_ProjToScreen( 0, 0,  ex, ey);
//	GameRectR_ProjToScreen( KlePoleW, KlePoleH,  ex2, ey2);
//	NomBlend(38);  ColorMatF();  mapDarkTexBind();
//	DrawQuad2D_2tcw( ex,ey,  ex2,ey2);
		//DrawQuad2D_2( ex,ey,  ex2,ey2);
		//.     .
		//    -  -  .

}



};


t_masKle masKle;






















void AnGener_Land02()
{
	masKle.GenerClearLand();


	// ---         .

	float haf = KlePoleW / 2.f;
	float qva = KlePoleW / 4.f;
	float k3 = KleW * 3.f;

	int gx, gz, gw, gh;
	gx = haf - qva + k3;  gz = haf - k3;
	gw = haf + qva - k3;  gh = haf + k3;
	gw = gw - gx;  gh = gh - gz;

	int lx, lz, lw, lh;
	lx = haf - qva + k3;  lz = haf - qva + k3;
	lw = haf - qva + k3 +k3;  lh = haf + qva - k3;
	lw = lw - lx;  lh = lh - lz;

	int rx, rz, rw, rh;
	rx = haf + qva - k3 - k3;  rz = haf - qva + k3;
	rw = haf + qva - k3;  rh = haf + qva - k3;
	rw = rw - rx;  rh = rh - rz;


	int k;
	for( k =0; k < KleMasKlv; k++) //   
	{
		if( masKle.RectOver( k, gx, gz, gw, gh)
		 || masKle.RectOver( k, lx, lz, lw, lh)
		 || masKle.RectOver( k, rx, rz, rw, rh)
			)
		{
			masKle.SetK( k, klHodWall, 0, 0, klVisRock);
		}
	}


	// ---    

	k = LentaPoleFrom0_NomYchUnder2( haf, haf - qva,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost, 0, klVisPost);

	// --- 
	k = LentaPoleFrom0_NomYchUnder2( haf - qva -k3, haf - qva - k3 - k3,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost, 0, klVisPost);

	k = LentaPoleFrom0_NomYchUnder2( haf + qva +k3, haf - qva - k3 - k3,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost, 0, klVisPost);




	k = LentaPoleFrom0_NomYchUnder2( haf, haf + qva,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost, 0, klVisPost);

	// --- 
	k = LentaPoleFrom0_NomYchUnder2( haf - qva -k3, haf + qva + k3 + k3,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost, 0, klVisPost);

	k = LentaPoleFrom0_NomYchUnder2( haf + qva +k3, haf + qva + k3 + k3,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost, 0, klVisPost);



	//   - 
	k = LentaPoleFrom0_NomYchUnder2( KleW*5, haf,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost2, 0, klVisPost2);

	k = LentaPoleFrom0_NomYchUnder2( KlePoleW - KleW*6, haf,
			0, 0, KleW, KleW, KleXKlv, KleZKlv);
	masKle.SetK( k, klHodLand, klStroPost2, 0, klVisPost2);



	// ---  
//	k = LentaPoleFrom0_NomYchUnder2( haf +2, haf +2,
//			0, 0, KleW, KleW, KleXKlv, KleZKlv);
//	masKle.SetK( k, klHodWall, klStroNone, 0, klVisCtrl);



	masKle.RestoreBort(); //   
	masKle.ReVisualBort();
}





void AnGenerMap001()
{
/*
   . -   .  
  -  -     
    .     ,  
   .   GenerMap   
  "   ".
*/
	AnGener_Land02();


}








