// now load only TGA  //save only BMP screens

// img_up.cpp
//     "   "   .
//      - (  *.cpp )
//---------


// ---
//  JpegDecodeTo    " JPG   ZIP".
//   --       OGL.
//
//   JPG & TGA  "  " -    .
//  JPG "" ,  " "   ( ).
//  ,         .


// ---
//  TargaDecodeTo    " TGA   ZIP".
//   --       OGL.


// ---
//  fileBMP24To   TargaDecodeTo & JpegDecodeTo,    - 
//  ,    -     ...
//       " BMP  ".


// ---
//  writeBmp24     -.
//      .


// ---
// VertikMirror     " ".






// -------------   (  TargaDecodeTo) ..
//	// FILE* f            
//	BYTE*  bData = 0;    // BYTE "mean" unsigned char;  // mean BYTE "unsigned char";
//	bData = (BYTE*)malloc(size);  if(!bData) {fclose(f); return 0;}//   
//	//{
//		fread( bData, size, 1, f);  fclose(f); //  .// 
//		int tW, tH, tBit;
//		BYTE* pixOutData = TargaDecodeTo( bData,  tW, tH, tBit);//    OGL
//		if( ! pixOutData ) {free(bData); return 0;}// -,    -    
//		//{
//			anRes = crtTexOGL( toNom, pixOutData, tW, tH, tBit==32? 1:0); //  
//			free(pixOutData); //  
//		//}
//		free(bData);//    (    *.TGA).
//	//}
//--------------



// --- -- ---   ...
// tex_pix.h  // d:/sla-org/include
// int SaveBMP_FromStdPix(const char *filename, Pix_& anPix) // const char
// int OGL_SaveViewportToBMP( sStr FileName )
//---------








#pragma pack (push, 1)
typedef struct
{
	unsigned char	id_length;
	unsigned char	colormap_type;
	unsigned char	image_type;

	unsigned short	colormap_index;
	unsigned short	colormap_length;

	unsigned char	colormap_size;

	unsigned short	x_origin, y_origin;
	unsigned short	width, height;
	unsigned char	pixel_size;
	unsigned char	attributes;
}
tga_header_t; // targa file header



typedef struct
{
	char* data;
	int  width;
	int  height;
}
picinfo_t;


//int jpeg_decompress( char* buf, int size, picinfo_t* pic);
//	#pragma comment(lib, "jpeg.lib")


//#include <gl/glaux.h>
//	#pragma comment(lib, "glaux.lib")
//fileBMP24To



#include "img_up.h"



#include <windows.h> //MessageBox

//#include <stdlib.h>
#include <stdio.h>
#include <memory.h> //malloc









void VMirror( unsigned char* bData, int w, int h, int bytesInPixel)
{
	if( ! bData) return;
	if(h < 2 || w < 0) return;
	switch(bytesInPixel)
	{
	case 1: case 2: case 3: case 4:  break; // .
	default: return;
	}

	int bytesInLine = w * bytesInPixel;
	unsigned char* bLine = (unsigned char*) malloc( bytesInLine);

	int oNew = bytesInLine * (h -1);
	int t;
	h = h / 2;

	for( int i =0; i < h; i++) //   
	{
		t = bytesInLine * i;
		memcpy( bLine, &bData[t], bytesInLine ); //   
				memcpy( &bData[t], &bData[oNew], bytesInLine );
							memcpy( &bData[oNew], bLine, bytesInLine );
		oNew -= bytesInLine;
	}

	free( bLine);
}







unsigned char* VertikMirror( unsigned char* bytes, short width, short height, short bpp)
{
int i, BytesInStroka=0, OffsetOld, OffsetNew;
short PixelByte;
unsigned char* OldData = NULL;

	if( ! bytes) return bytes; //    
	if(height < 2) return bytes;
	if(width < 0) return bytes;

	switch(bpp)
	{
	case 8: PixelByte=1; break;
	case 16: PixelByte=2;break;
	case 24: PixelByte=3;break;
	case 32: PixelByte=4;break;
	default: return bytes;
	}

	//-----
	//     ,    
	//      ...
	// -----
	//  ,     
	//         
	//   -   , 
	//     ,       ...

	OldData = bytes;
	bytes = (unsigned char*) malloc(width * height * PixelByte);

	BytesInStroka = width * PixelByte;
	OffsetNew = BytesInStroka * (height-1);

	for(i=0; i < height; i++) //   
	{
		OffsetOld = BytesInStroka * i;
		memcpy( &bytes[OffsetNew], &OldData[OffsetOld], BytesInStroka ); //   
		OffsetNew -= BytesInStroka;
	}

	free(OldData);
	return bytes; //  
}















/*
unsigned char* JpegDecodeTo( char* fileData, int fileDataSize,
			int& pixOutW, int& pixOutH)
{
	picinfo_t  pic;
	pic.data = NULL;

	unsigned char* pixOutData = 0;

	if(1) //if( jpeg_decompress(fileData, fileDataSize, &pic) )
	{
		//MessageBox( NULL, "DeCompress Jpeg image", "Error", NULL);
		MessageBox( NULL, "Now not support Jpeg", "Error", NULL);
		return 0;
	}
	if(! pic.data) return 0;

	pixOutData = (unsigned char*)pic.data;
	pixOutW = pic.width;
	pixOutH = pic.height;

	return VertikMirror( pixOutData, pixOutW, pixOutH, 24);
}
*/













unsigned char* TargaDecodeTo( unsigned char* fileData,
			int& pixOutW, int& pixOutH, int& pixOutBit)
{
	int width, height, numPixels, row, column;

	unsigned char  r, g, b, a;
	unsigned char  j, packetHeader, packetSize, bytesPerPixel;

	unsigned char* pixOutData = 0;
	unsigned char*  rgba;
	unsigned char*  dest;

	tga_header_t*  header;


	header = (tga_header_t*) fileData;
	fileData += sizeof(tga_header_t);




	if( header->image_type != 2  &&  header->image_type != 10 )
	{
		MessageBox( NULL, "Only TGA (Uncompr. RGB) or (RLE RGB) image types", "Error", NULL);
		return 0;
	}

	if(  header->colormap_type != 0
		||(header->pixel_size!=32 && header->pixel_size!=24)  )
	{ // Only 24bit or 32bit pixels are supported
		MessageBox( NULL, "Only TGA (24) or (32) bit pixel", "Error", NULL);
		return 0;
	}


	pixOutBit = header->pixel_size;

	width = header->width;
	height = header->height;
	pixOutW = width;
	pixOutH = height;



	numPixels = width * height;
	bytesPerPixel = (header->pixel_size == 32) ? 4 : 3;


	// Allocate memory for decoded image
	rgba = (unsigned char*) malloc( numPixels * bytesPerPixel);
	if( ! rgba)
	{
		MessageBox( NULL, "TargaDecode can't allocate memory", "Error", NULL);
		return 0;
	}




	if( header->image_type == 2) // Uncompressed image
	{
		row = height;
		while( (row--) > 0 )
		{
			if( header->attributes & 0x20)
				dest = rgba + (height - row - 1) * width * bytesPerPixel;
			else
				dest = rgba + row * width * bytesPerPixel;

			for( column=0; column<width; column++)
			{
				if (header->pixel_size == 24)
				{
					b = *fileData++;
					g = *fileData++;
					r = *fileData++;
					*dest++ = r;
					*dest++ = g;
					*dest++ = b;
				} else
				if (header->pixel_size == 32)
				{
					b = *fileData++;
					g = *fileData++;
					r = *fileData++;
					a = *fileData++;
					*dest++ = r;
					*dest++ = g;
					*dest++ = b;
					*dest++ = a;
				}
			}//for
		}//while u

	}
	else if( header->image_type==10 ) // RLE image
	{
		row = height;
		while( (row--) > 0 )
		{
			if( header->attributes & 0x20)
				dest = rgba + (height - row - 1) * width * bytesPerPixel;
			else
				dest = rgba + row * width * bytesPerPixel;

			for(column=0; column<width; )
			{
				packetHeader = *fileData++;
				packetSize = 1 + (packetHeader & 0x7f);
				// RLE packet
				if (packetHeader & 0x80)
				{
					if (header->pixel_size==24)
					{
						b = *fileData++;
						g = *fileData++;
						r = *fileData++;
					} else
					if (header->pixel_size==32)
					{
						b = *fileData++;
						g = *fileData++;
						r = *fileData++;
						a = *fileData++;
					}
					for (j=0; j<packetSize; j++)
					{
						*dest++ = r;
						*dest++ = g;
						*dest++ = b;
						if(header->pixel_size==32) *dest++ = a;
						column++;
						if (column == width)
						{
							column = 0;
							if (row > 0) row--;
							else goto end_decode;

							if (header->attributes & 0x20)
								dest = rgba + (height - row - 1) * width * bytesPerPixel;
							else
								dest = rgba + row * width * bytesPerPixel;
						}
					}
				} else
				{// Non-RLE packet
					for (j=0; j<packetSize; j++)
					{
						if (header->pixel_size == 24)
						{
							b = *fileData++;
							g = *fileData++;
							r = *fileData++;
							*dest++ = r;
							*dest++ = g;
							*dest++ = b;
						} else
						{
							b = *fileData++;
							g = *fileData++;
							r = *fileData++;
							a = *fileData++;
							*dest++ = r;
							*dest++ = g;
							*dest++ = b;
							*dest++ = a;
						}
						column++;
						if (column == width)
						{
							column = 0;
							if (row > 0) row--;
							else goto end_decode;
							if (header->attributes & 0x20)
								dest = rgba + (height - row - 1) * width * bytesPerPixel;
							else
								dest = rgba + row * width * bytesPerPixel;
						}
					}
				}
			}//for
			end_decode: ;

		}//while rle

	}//else if RLE image


	pixOutData = rgba;

	return VertikMirror( pixOutData,  pixOutW, pixOutH, pixOutBit);
}



























//	This function writes out a 24-bit Windows bitmap file that is readable by Microsoft Paint.
//   The image data	is a 1D array of (r, g, b) triples, where individual (r, g, b) values can
//	each take on values between 0 and 255, inclusive.
//
//   The input to the function is:
//	   char *filename:						A string representing the filename that will be written
//		unsigned int width:					The width, in pixels, of the bitmap
//		unsigned int height:					The height, in pixels, of the bitmap
//		unsigned char *image:				The image data, where each pixel is 3 unsigned chars (r, g, b)
//
//   Written by Greg Slabaugh (slabaugh@ece.gatech.edu), 10/19/00

int writeBmp24(const char* filename, int width, int height,
					  unsigned char* image, int VertikPere, int SwapToBGR)
{
	BITMAPINFOHEADER bmpInfoHeader;
	BITMAPFILEHEADER bmpFileHeader;

	FILE* filep;

	int row, column;
	int extrabytes, bytesize;

	unsigned char* paddedImage = NULL;
	unsigned char* paddedImagePtr = NULL;
	unsigned char* imagePtr = NULL;


// The .bmp format requires that the image data is aligned on a 4 byte boundary.  For 24 - bit bitmaps,
//	   this means that the width of the bitmap  * 3 must be a multiple of 4. This code determines
//	   the extra padding needed to meet this requirement.
   extrabytes = (4 - (width * 3) % 4) % 4;

	// This is the size of the padded bitmap
	bytesize = (width * 3 + extrabytes) * height;

	// Fill the bitmap file header structure
	bmpFileHeader.bfType = 19778; //Bitmap header
	bmpFileHeader.bfSize = 0;     // This can be 0 for BI_RGB bitmaps
	bmpFileHeader.bfReserved1 = 0;
	bmpFileHeader.bfReserved2 = 0;
	bmpFileHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	// Fill the bitmap info structure
	bmpInfoHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfoHeader.biWidth = width;
	bmpInfoHeader.biHeight = height;
	bmpInfoHeader.biPlanes = 1;
	bmpInfoHeader.biBitCount = 24;
	bmpInfoHeader.biCompression = BI_RGB;
	bmpInfoHeader.biSizeImage = bytesize;  // includes padding for 4 byte alignment
	bmpInfoHeader.biXPelsPerMeter = 2952;
	bmpInfoHeader.biYPelsPerMeter = 2952;
	bmpInfoHeader.biClrUsed = 0;
	bmpInfoHeader.biClrImportant = 0;


	// Open file
	if( (filep = fopen(filename, "wb")) == NULL )
	{
		MessageBox( NULL, "Save BMP24 image", "Error", NULL); return 0;
	}

	// Write bmp file header
	if( fwrite(&bmpFileHeader, 1, sizeof(BITMAPFILEHEADER), filep) < sizeof(BITMAPFILEHEADER))
	{
		//printf("Error writing bitmap file header\n");
		MessageBox( NULL, "Save BMP24 image", "Error", NULL);
		fclose(filep);
		return 0;
	}

	// Write bmp info header
	if( fwrite(&bmpInfoHeader, 1, sizeof(BITMAPINFOHEADER), filep) < sizeof(BITMAPINFOHEADER) )
	{
		//printf("Error writing bitmap info header\n");
		MessageBox( NULL, "Save BMP24 image", "Error", NULL);
		fclose(filep);
		return 0;
	}

	// Allocate memory for some temporary storage
	paddedImage = (unsigned char*) calloc( sizeof(unsigned char), bytesize);
	if(paddedImage == NULL)
	{
		//printf("Error allocating memory \n");
		//LogInfo("\n Error allocating memory (bitmap24)");
		MessageBox( NULL, "Save BMP24 (allocating temporary memory)", "Error", NULL);
		fclose(filep);
		return 0;
	}


	if( VertikPere )
	{
	// This code does three things.  First, it flips the image data upside down, as the .bmp
	//   format requires an upside down image.  Second, it pads the image data with extrabytes
	//	number of bytes so that the width in bytes of the image data that is written to the
	//	file is a multiple of 4.  Finally, it swaps (r, g, b) for (b, g, r).  This is another
	//	quirk of the .bmp file format.
		for( row = 0; row < height; row++)
		{
			imagePtr = image + (height - 1 - row) * width * 3;
			paddedImagePtr = paddedImage + row * (width * 3 + extrabytes);

			for( column = 0; column < width; column++) // 
			{
				if(SwapToBGR)
				{
					*paddedImagePtr = *(imagePtr + 2);
					*(paddedImagePtr + 1) = *(imagePtr + 1);
					*(paddedImagePtr + 2) = *imagePtr;
				}
				else
				{
					*paddedImagePtr = *imagePtr;
					*(paddedImagePtr + 1) = *(imagePtr + 1);
					*(paddedImagePtr + 2) = *(imagePtr + 2);
				}

				imagePtr += 3;
				paddedImagePtr += 3;
			}
		}

	}
	else
	{
		for( row = 0; row < height; row++)
		{
			imagePtr = image + row * (width * 3); // <<<<--------
			paddedImagePtr = paddedImage + row * (width * 3 + extrabytes);

			for( column = 0; column < width; column++) // 
			{
				if(SwapToBGR)
				{
					*paddedImagePtr = *(imagePtr + 2);
					*(paddedImagePtr + 1) = *(imagePtr + 1);
					*(paddedImagePtr + 2) = *imagePtr;
				}
				else
				{
					*paddedImagePtr = *imagePtr;
					*(paddedImagePtr + 1) = *(imagePtr + 1);
					*(paddedImagePtr + 2) = *(imagePtr + 2);
				}

				imagePtr += 3;
				paddedImagePtr += 3;
			}
		}

	}// non vertikPere



	// Write bmp data
	if( fwrite(paddedImage, 1, bytesize, filep) < bytesize)
	{
		//printf("Error writing bitmap data\n");
		//LogInfo("\n Error writing bitmap24 data.");
		MessageBox( NULL, "Save BMP24 image (fwrite)", "Error", NULL);

		free(paddedImage);
		fclose(filep);
		return 0;
	}


	fclose(filep);
	free(paddedImage);
	return 1;
}








